Attribute VB_Name = "USBIOXDLL"
Option Explicit
' 2004.05.28, 2004.10.20, 2005.01.08, 2005.03.25, 2005.04.28
'****************************************
'**  Copyright  (C)  W.ch  1999-2005   **
'**  Web:  http://www.USB-I2C-SPI.com  **
'****************************************
'**  DLL for USB interface chip USB2I2C**
'**  C, VC6.0                          **
'****************************************
'
Public Enum EEPROM_TYPE   ' EEPROMͺŶ
  ID_24C01 = 0
  ID_24C02 = 1
  ID_24C04 = 2
  ID_24C08 = 3
  ID_24C16 = 4
  ID_24C32 = 5
  ID_24C64 = 6
  ID_24C128 = 7
  ID_24C256 = 8
  ID_24C512 = 9
  ID_24C1024 = 10
  ID_24C2048 = 11
  ID_24C4096 = 12
End Enum

Type mUspValue
        mUspValueLow As Byte                  ' 02H ֵֽ
        mUspValueHigh As Byte                 ' 03H ֵֽ
End Type
Type mUspIndex
        mUspIndexLow As Byte                  ' 04H ֽ
        mUspIndexHigh  As Byte                ' 05H ֽ
End Type
Type USB_SETUP_PKT                            ' USBƴĽ׶εṹ
    mUspReqType As Byte                       ' 00H 
    mUspRequest As Byte                       ' 01H 
    mUspValue As mUspValue                    ' 02H-03H ֵ
    mUspIndex As mUspIndex                    ' 04H-05H 
    mLength As Integer                        ' 06H-07H ݽ׶εݳ
End Type

Public Const INVALID_HANDLE_VALUE = -1        '
Public Const mUSBIO_PACKET_LENGTH = 32           ' USB2I2Cֵ֧ݰĳ
Public Const mUSBIO_PKT_LEN_SHORT = 8               ' USB2I2Cֵ֧Ķݰĳ

Type WIN32_COMMAND                              'WIN32ӿڽṹ
   mFunction As Long                            'ʱָܴ߹ܵ
                                                'ʱز״̬
   mLength As Long                              'ȡ,غݵĳ
   mBuffer(mUSBIO_PACKET_LENGTH - 1) As Byte    'ݻ,Ϊ0255B
End Type
Public mWIN32_COMMAND As WIN32_COMMAND

Public Const FILE_DEVICE_UNKNOWN = &H22
Public Const FILE_ANY_ACCESS = 0
Public Const METHOD_BUFFERED = 0
' WIN32Ӧòӿ
Public Const IOCTL_USBIO_COMMAND = (FILE_DEVICE_UNKNOWN * (2 ^ 16) + FILE_ANY_ACCESS * 2 ^ 14 + &HF34 * 2 ^ 2 + METHOD_BUFFERED)     ' רýӿ

Const mWIN32_COMMAND_HEAD = 8         ' WIN32ӿڵͷ

Public Const mUSBIO_MAX_NUMBER = 16              ' ͬʱӵUSB2I2C

Public Const mMAX_BUFFER_LENGTH = &H1000              ' ݻ󳤶4096

Public Const mMAX_COMMAND_LENGTH = (mWIN32_COMMAND_HEAD + mMAX_BUFFER_LENGTH)             ' ݳȼṹͷĳ

Public Const mDEFAULT_BUFFER_LEN = &H400              ' ݻĬϳ1024

Public Const mDEFAULT_COMMAND_LEN = (mWIN32_COMMAND_HEAD + mDEFAULT_BUFFER_LEN)       ' Ĭݳȼṹͷĳ


' USB2I2C˵ַ
Public Const mUSBIO_ENDP_INTER_UP = &H81              ' USB2I2Cжϴ˵ĵַ
Public Const mUSBIO_ENDP_INTER_DOWN = &H1             ' USB2I2Cж´˵ĵַ
Public Const mUSBIO_ENDP_DATA_UP = &H82              ' USB2I2Cݿϴ˵ĵַ
Public Const mUSBIO_ENDP_DATA_DOWN = &H2            ' USB2I2Cݿ´˵ĵַ

' 豸ӿṩĹܵ
Public Const mPipeDeviceCtrl = &H4                  ' USB2I2CۺϿƹܵ
Public Const mPipeInterUp = &H5                       ' USB2I2Cжϴܵ
Public Const mPipeDataUp = &H6                         ' USB2I2Cݿϴܵ
Public Const mPipeDataDown = &H7                     ' USB2I2Cݿ´ܵ

' ӦòӿڵĹܴ
Public Const mFuncNoOperation = &H0                  ' ޲
Public Const mFuncGetVersion = &H1                    ' ȡ汾
Public Const mFuncGetConfig = &H2                   ' ȡUSB豸
Public Const mFuncSetTimeout = &H9                    ' USBͨѶʱ
Public Const mFuncSetExclusive = &HB                  ' öռʹ
Public Const mFuncResetDevice = &HC                  ' λUSB豸
Public Const mFuncResetPipe = &HD                     ' λUSBܵ
Public Const mFuncAbortPipe = &HE                      ' ȡUSBܵ

' USB2I2CרõĹܴ
Public Const mFuncSetParaMode = &HF                   ' òģʽ
Public Const mFuncReadData0 = &H10                   ' Ӳڶȡݿ0
Public Const mFuncReadData1 = &H11                   ' Ӳڶȡݿ1
Public Const mFuncWriteData0 = &H12                  ' 򲢿дݿ0
Public Const mFuncWriteData1 = &H13                  ' 򲢿дݿ1
Public Const mFuncWriteRead = &H14                    ' 


' USB豸׼
Public Const mUSB_CLR_FEATURE = &H1
Public Const mUSB_SET_FEATURE = &H3
Public Const mUSB_GET_STATUS = &H0
Public Const mUSB_SET_ADDRESS = &H5
Public Const mUSB_GET_DESCR = &H6
Public Const mUSB_SET_DESCR = &H7
Public Const mUSB_GET_CONFIG = &H8
Public Const mUSB_SET_CONFIG = &H9
Public Const mUSB_GET_INTERF = &HA
Public Const mUSB_SET_INTERF = &HB
Public Const mUSB_SYNC_FRAME = &HC

' USB2I2Cƴĳר
Public Const mUSBIO_VENDOR_READ = &HC0                ' ͨƴʵֵUSB2I2Cרö
Public Const mUSBIO_VENDOR_WRITE = &H40             ' ͨƴʵֵUSB2I2Cרд

' USB2I2Cƴĳר
Public Const mUSBIO_PARA_INIT = &HB1                 ' ʼ
Public Const mUSBIO_I2C_STATUS = &H52                ' ȡI2Cӿڵ״̬
Public Const mUSBIO_I2C_COMMAND = &H53               ' I2Cӿڵ


Public Const mUSBIOA_CMD_I2C_STM_STA = &H74          ' I2Cӿڵ:ʼλ
Public Const mUSBIOA_CMD_I2C_STM_STO = &H75           ' I2Cӿڵ:ֹͣλ
Public Const mUSBIOA_CMD_I2C_STM_OUT = &H0           'I2Cӿڵ:,λ5-λ0Ϊ,ֽΪ,0ֻһֽڲӦ
Public Const mUSBIOA_CMD_I2C_STM_IN = &HC0           ' I2Cӿڵ:,λ5-λ0Ϊ,0ֻһֽڲӦ
Public Const mUSBIOA_CMD_I2C_STM_SET = &H60           ' I2Cӿڵ:ò,λ2=SPII/O(0=뵥,1=˫˫),λ1λ0=I2Cٶ(00=,01=׼,10=,11=)
Public Const mUSBIOA_CMD_I2C_STM_US = &H40           ' I2Cӿڵ:΢Ϊλʱ,λ3-λ0Ϊʱֵ
Public Const mUSBIOA_CMD_I2C_STM_MS = &H50           ' I2Cӿڵ:Ϊλʱ,λ3-λ0Ϊʱֵ
Public Const mUSBIOA_CMD_I2C_STM_DLY = &HF           ' I2Cӿڵʱֵ
Public Const mUSBIOA_CMD_I2C_STM_END = &H0            ' I2Cӿڵ:ǰ


' ֱ״̬źŵλ
Public Const mStateBitERR = &H100                     ' ֻ,ERR#״̬,1:ߵƽ,0:͵ƽ
Public Const mStateBitPEMP = &H200                   ' ֻ,PEMP״̬,1:ߵƽ,0:͵ƽ
Public Const mStateBitINT = &H400                     ' ֻ,INT#״̬,1:ߵƽ,0:͵ƽ
Public Const mStateBitSLCT = &H800                  ' ֻ,SLCT״̬,1:ߵƽ,0:͵ƽ
Public Const mStateBitSDA = &H800000              ' ֻ,SDA״̬,1:ߵƽ,0:͵ƽ




Declare Function USBIO_OpenDevice Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long
' USB2I2C豸,ؾ,Ч
' iIndex  ָUSB2I2C豸,0Ӧһ豸

Declare Sub USBIO_CloseDevice Lib "USBIOX.DLL" (ByVal iIndex As Long)
' رUSB2I2C豸
' iIndex    ָUSB2I2C豸

Declare Function USBIO_GetVersion Lib "USBIOX.DLL" () As Long

' DLL汾,ذ汾

Declare Function USBIO_DriverCommand Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef ioCommand As WIN32_COMMAND) As Long
' ֱӴ,򷵻0,򷵻ݳ
' iIndex,  ' ָUSB2I2C豸,V1.6DLLҲ豸򿪺ľ
' ioCommand   ṹĵַ
' óڵú󷵻ݳ,Ȼṹ,Ƕ,ݷṹ,
' صݳڲʧʱΪ0,ɹʱΪṹĳ,һֽ,򷵻mWIN32_COMMAND_HEAD+1,
' ṹڵǰ,ֱṩ:ܵŻܴ,ȡݵĳ(ѡ),(ѡ)
' ṹڵú,ֱ𷵻:״̬,ݵĳ(ѡ),
'   ״̬WINDOWSĴ,ԲοNTSTATUS.H,
'   ݵĳָصݳ,ݴĻ,дһΪ0

Declare Function USBIO_GetDrvVersion Lib "USBIOX.DLL" () As Long

' 汾,ذ汾,򷵻0

Declare Function USBIO_ResetDevice Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean

'λUSB豸
' iIndex  ָUSB2I2C豸

Declare Function USBIO_GetDeviceDescr Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡ豸
' iIndex,   ָUSB2I2C豸
' oBuffer   ָһ㹻Ļ,ڱ
' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_GetConfigDescr Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡ
'  iIndex,    ָUSB2I2C豸
'  oBuffer,   ָһ㹻Ļ,ڱ
'  ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_SetIntRoutine Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iIntRoutine As Long) As Boolean
'趨жϷ
' ָUSB2I2C豸
'ָжϷ,ΪNULLȡжϷ,жʱøó


Declare Function USBIO_ReadInter Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iStatus As Long) As Boolean
' ȡж
' iIndex,  ָUSB2I2C豸
' iStatus   ָһ˫ֵԪ,ڱȡж״̬,
' λ7-λ0ӦUSB2I2CD7-D0
'  λ8ӦUSB2I2CERR#, λ9ӦUSB2I2CPEMP, λ10ӦUSB2I2CINT#, λ11ӦUSB2I2CSLCT

Declare Function USBIO_AbortInter Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' жݶ
' iIndex   ָUSB2I2C豸

Declare Function USBIO_ReadData0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' 0#˿ڶȡݿ
 ' iIndex     ָUSB2I2C豸
 ' oBuffer   ָһ㹻Ļ,ڱȡ
 ' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_ReadData1 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' 1#˿ڶȡݿ
' iIndex,  ָUSB2I2C豸
' oBuffer ָһ㹻Ļ,ڱȡ
' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_AbortRead Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' ݿ
' iIndex    ָUSB2I2C豸

Declare Function USBIO_WriteData0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
' 0#˿дݿ
' iIndex,    ָUSB2I2C豸
' iBuffer     ָһ,׼д
' ioLength  ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_WriteData1 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
' 1#˿дݿ
' iIndex,    ָUSB2I2C豸
' iBuffer,    ָһ,׼д
' ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_AbortWrite Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' ݿд
' iIndex   ָUSB2I2C豸

Declare Function USBIO_GetStatus Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iStatus As Long) As Boolean
'  ͨUSB2I2Cֱݺ״̬
'  iIndex,   ָUSB2I2C豸
'  iStatus  ָһ˫ֵԪ,ڱ״̬,
'  λ7-λ0ӦUSB2I2CD7-D0
'  λ8ӦUSB2I2CERR#, λ9ӦUSB2I2CPEMP, λ10ӦUSB2I2CINT#, λ11ӦUSB2I2CSLCT, λ23ӦUSB2I2CSDA
'  λ13ӦUSB2I2CBUSY/WAIT#, λ14ӦUSB2I2CAUTOFD#/DATAS#,λ15ӦUSB2I2CSLCTIN#/ADDRS#

Declare Function USBIO_ReadI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDevice As Byte, ByVal iAddr As Byte, ByRef oByte As Byte) As Boolean

'  I2Cӿڶȡһֽ
'  iIndex,   ָUSB2I2C豸
'  iDevice,    7λָI2C豸ַ
'  iAddr,    ָݵԪĵַ
'  oByte    ָһֽڵԪ,ڱȡֽ

Declare Function USBIO_WriteI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDevice As Byte, ByVal iAddr As Byte, ByVal iByte As Byte) As Boolean

'    I2Cӿдһֽ
'    iIndex,   ָUSB2I2C豸
'    iDevice,   7λָI2C豸ַ
'    iAddr,  ָݵԪĵַ
'    iByte  дֽ

Declare Function USBIO_SetExclusive Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iExclusive As Long) As Boolean
' öռʹõǰUSB2I2C豸
' iIndex,    ָUSB2I2C豸
' iExclusive  Ϊ0豸Թʹ,0ռʹ

Declare Function USBIO_SetTimeout Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteTimeout As Long, ByVal iReadTimeout As Long) As Boolean
'  USBݶдĳʱ
'  iIndex,  // ָUSB2I2C豸
'  iWriteTimeout  ָUSBдݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
'  iReadTimeout  ָUSBȡݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)

Declare Function USBIO_ReadData Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡݿ
' iIndex,    ָUSB2I2C豸
' oBuffer,    ָһ㹻Ļ,ڱȡ
' ioLength      ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_WriteData Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
'  дݿ
'  iIndex,    ָUSB2I2C豸
'  iBuffer,    ָһ,׼д
'  ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_GetDeviceName Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long           ''''
' ָUSB2I2C豸ƵĻ,򷵻NULL
' iIndex   ָUSB2I2C豸,0Ӧһ豸

Declare Function USBIO_FlushBuffer Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' USB2I2CĻ
' iIndex   ָUSB2I2C豸

Declare Function USBIO_WriteRead Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteLength As Long, ByRef iWriteBuffer As Any, ByVal iReadStep As Long, ByVal iReadTimes As Long, ByRef oReadLength As Long, ByRef oReadBuffer As Any) As Boolean
' USBIO_WriteRead   ִ,
' iIndex,    ָUSB2I2C豸
' iWriteLength,   д,׼дĳ
' iWriteBuffer,    ָһ,׼д
' iReadStep,    ׼ȡĵĳ, ׼ȡܳΪ(iReadStep*iReadTimes)
' iReadTimes,    ׼ȡĴ
' oReadLength,    ָ򳤶ȵԪ,غΪʵʶȡĳ
' oReadBuffer      ָһ㹻Ļ,ڱȡ

Declare Function USBIO_SetStream Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iMode As Long) As Boolean
' USBIO_SetStream   ôģʽ
' iIndex,    ָUSB2I2C豸
' iMode      ָģʽ,
' λ1-λ0: I2Cӿٶ/SCLƵ, 00=/20KHz,01=׼/100KHz,10=/400KHz,11=/750KHz
' λ2:     SPII/O/IO, 0=뵥(D5/D7),1=˫˫(D5D4/D7D6)
' λ7:     SPIֽеλ˳, 0=λǰ, 1=λǰ
' ,Ϊ0

Declare Function USBIO_SetDelaymS Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDelay As Long) As Boolean
'  USBIO_SetDelaymS     Ӳ첽ʱ,úܿ췵,һ֮ǰʱָ
 ' iIndex,    ָUSB2I2C豸
 ' iDelay      ָʱĺ

Declare Function USBIO_StreamI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteLength As Long, ByRef iWriteBuffer As Any, ByVal iReadLength As Long, ByRef oReadBuffer As Any) As Boolean
' USBIO_StreamI2C     I2C,2߽ӿ,ʱΪSCL,ΪSDA(׼˫I/O),ٶԼ56Kֽ
' iIndex,    ָUSB2I2C豸
' iWriteLength,    ׼дֽ
' iWriteBuffer,    ָһ,׼д,ֽͨI2C豸ַдλ
' iReadLength,     ׼ȡֽ
' oReadBuffer     ָһ,غǶ
Declare Function USBIO_ReadEEPROM Lib "USBIOX.DLL" (ByVal iIndexas As Long, ByVal iEepromID As EEPROM_TYPE, ByVal iAddr As Long, ByVal iLength As Long, ByRef oBuffer As Any) As Boolean
' i    Index  ָUSB2I2C豸
' iEepromID   ָEEPROMͺ
' iAddr       ָݵԪĵַ
' iLength     ׼ȡֽ
' oBuffer     ָһ,غǶ

Declare Function USBIO_WriteEEPROM Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEepromID As EEPROM_TYPE, ByVal iAddr As Long, ByVal iLength As Long, ByRef iBuffer As Any) As Boolean
' iIndex,    ָUSB2I2C豸
' iEepromID, ָEEPROMͺ
' iAddr,     ָݵԪĵַ
' iLength,   ׼дֽ
' iBuffer    ָһ,׼д

Declare Function USBIO_SetBufUpload Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEnableOrClear As Long) As Boolean  ' Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
' USBIO_SetBufUpload  ' 趨ڲϴģʽ
' iIndex,          0ָUSB2I2C豸,0Ӧһ豸
' iEnableOrClear  Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
' ڲϴģʽ,ôUSB2I2C򴴽߳ԶUSBϴݵڲ,ͬʱе,ӦóUSBIO_ReadDataػе

Declare Function USBIO_QueryBufUpload Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long
' USBIO_QueryBufUpload   ѯڲϴеݰ,ɹݰ,-1
' iIndex                ָUSB2I2C豸,0Ӧһ豸

Declare Function USBIO_SetBufDownload Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEnableOrClear As Long) As Boolean
'  USBIO_SetBufDownload  趨ڲ´ģʽ
'  iIndex,              ָUSB2I2C豸,0Ӧһ豸
'  iEnableOrClear       Ϊ0ֹڲ´ģʽ,ʹֱ´,0ڲ´ģʽе
'  ڲ´ģʽ,ôӦóUSBIO_WriteData󽫽ǽUSB´ݷŵڲ,USB2I2C򴴽߳Զֱ

Declare Function USBIO_QueryBufDownload Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long    ' ָUSB2I2C豸,0Ӧһ豸
'  USBIO_QueryBufDownload  ѯڲ´еʣݰ(δ),ɹݰ,-1
'  iIndex                 ָUSB2I2C豸,0Ӧһ豸


Declare Function USBIO_ResetInter Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'  USBIO_ResetInter   λжݶ
'  iIndex            ָUSB2I2C豸

Declare Function USBIO_ResetRead Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'  USBIO_ResetRead  λݿ
'  iIndex          ָUSB2I2C豸

Declare Function USBIO_ResetWrite Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'    USBIO_ResetRead    λݿ
'    iIndex            ָUSB2I2C豸

'typedef     VOID    ( CALLBACK  * mUSBIO_NOTIFY_ROUTINE ) (  ' 豸¼֪ͨص
'    ULONG           iEventStatus );  ' 豸¼͵ǰ״̬(ж): 0=豸γ¼, 3=豸¼

Public Const USBIO_DEVICE_ARRIVAL = 3               ' 豸¼,Ѿ
Public Const USBIO_DEVICE_REMOVE_PEND = 1         ' 豸Ҫγ
Public Const USBIO_DEVICE_REMOVE = 0              ' 豸γ¼,Ѿγ

Declare Function USBIO_SetDeviceNotify Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iDeviceID As String, ByVal iNotifyRoutine As Long) As Boolean
'  USBIO_SetDeviceNotify     趨豸¼֪ͨ
'  iIndex,                  ָUSB2I2C豸,0Ӧһ豸
'  iDeviceID,               ѡ,ַָ,ָص豸ID,ַ\0ֹ
'  iNotifyRoutine           (ַ)ָ豸¼ص, ΪNULLȡ¼֪ͨ, ڼ⵽¼ʱøó

