Option Strict Off
Option Explicit On
Module USBIOXDLL
	' 2004.05.28, 2004.10.20, 2005.01.08, 2005.03.25, 2005.04.28
	'****************************************
	'**  Copyright  (C)  W.ch  1999-2005   **
	'**  Web:  http://www.USB-I2C-SPI.com  **
	'****************************************
	'**  DLL for USB interface chip USB2ISP**
	'**  C, VC6.0                          **
	'****************************************
	'
	Public Enum EEPROM_TYPE ' EEPROMͺŶ
		ID_24C01 = 0
		ID_24C02 = 1
		ID_24C04 = 2
		ID_24C08 = 3
		ID_24C16 = 4
		ID_24C32 = 5
		ID_24C64 = 6
		ID_24C128 = 7
		ID_24C256 = 8
		ID_24C512 = 9
		ID_24C1024 = 10
		ID_24C2048 = 11
		ID_24C4096 = 12
	End Enum
	
	Structure mUspValue
		Dim mUspValueLow As Byte ' 02H ֵֽ
		Dim mUspValueHigh As Byte ' 03H ֵֽ
	End Structure
	Structure mUspIndex
		Dim mUspIndexLow As Byte ' 04H ֽ
		Dim mUspIndexHigh As Byte ' 05H ֽ
	End Structure
	Structure USB_SETUP_PKT ' USBƴĽ׶εṹ
		Dim mUspReqType As Byte ' 00H 
		Dim mUspRequest As Byte ' 01H 
		'UPGRADE_NOTE: mUspValue  mUspValue_Renamed ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"
		Dim mUspValue_Renamed As mUspValue ' 02H-03H ֵ
		'UPGRADE_NOTE: mUspIndex  mUspIndex_Renamed ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"
		Dim mUspIndex_Renamed As mUspIndex ' 04H-05H 
		Dim mLength As Short ' 06H-07H ݽ׶εݳ
	End Structure
	
	Public Const INVALID_HANDLE_VALUE As Short = -1 '
	Public Const mUSBIO_PACKET_LENGTH As Short = 32 ' USB2ISPֵ֧ݰĳ
	Public Const mUSBIO_PKT_LEN_SHORT As Short = 8 ' USB2ISPֵ֧Ķݰĳ
	
	Structure WIN32_COMMAND 'WIN32ӿڽṹ
		Dim mFunction As Integer 'ʱָܴ߹ܵ
		'ʱز״̬
		Dim mLength As Integer 'ȡ,غݵĳ
		<VBFixedArray(mUSBIO_PACKET_LENGTH - 1)> Dim mBuffer() As Byte 'ݻ,Ϊ0255B
		
		'UPGRADE_TODO: áInitializeʼ˽ṹʵ ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="B4BFF9E0-8631-45CF-910E-62AB3970F27B"
		Public Sub Initialize()
			ReDim mBuffer(mUSBIO_PACKET_LENGTH - 1)
		End Sub
	End Structure
	'UPGRADE_WARNING: ṹ mWIN32_COMMAND еҪȳʼſʹá ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="814DF224-76BD-4BB4-BFFB-EA359CB9FC48"
	Public mWIN32_COMMAND As WIN32_COMMAND
	
	Public Const FILE_DEVICE_UNKNOWN As Short = &H22s
	Public Const FILE_ANY_ACCESS As Short = 0
	Public Const METHOD_BUFFERED As Short = 0
	' WIN32Ӧòӿ
	Public Const IOCTL_USBIO_COMMAND As Double = (FILE_DEVICE_UNKNOWN * (2 ^ 16) + FILE_ANY_ACCESS * 2 ^ 14 + &HF34s * 2 ^ 2 + METHOD_BUFFERED) ' רýӿ
	
	Const mWIN32_COMMAND_HEAD As Short = 8 ' WIN32ӿڵͷ
	
	Public Const mUSBIO_MAX_NUMBER As Short = 16 ' ͬʱӵUSB2ISP
	
	Public Const mMAX_BUFFER_LENGTH As Short = &H1000s ' ݻ󳤶4096
	
	Public Const mMAX_COMMAND_LENGTH As Integer = (mWIN32_COMMAND_HEAD + mMAX_BUFFER_LENGTH) ' ݳȼṹͷĳ
	
	Public Const mDEFAULT_BUFFER_LEN As Short = &H400s ' ݻĬϳ1024
	
	Public Const mDEFAULT_COMMAND_LEN As Integer = (mWIN32_COMMAND_HEAD + mDEFAULT_BUFFER_LEN) ' Ĭݳȼṹͷĳ
	
	
	' USB2ISP˵ַ
	Public Const mUSBIO_ENDP_INTER_UP As Short = &H81s ' USB2ISPжϴ˵ĵַ
	Public Const mUSBIO_ENDP_INTER_DOWN As Short = &H1s ' USB2ISPж´˵ĵַ
	Public Const mUSBIO_ENDP_DATA_UP As Short = &H82s ' USB2ISPݿϴ˵ĵַ
	Public Const mUSBIO_ENDP_DATA_DOWN As Short = &H2s ' USB2ISPݿ´˵ĵַ
	
	' 豸ӿṩĹܵ
	Public Const mPipeDeviceCtrl As Short = &H4s ' USB2ISPۺϿƹܵ
	Public Const mPipeInterUp As Short = &H5s ' USB2ISPжϴܵ
	Public Const mPipeDataUp As Short = &H6s ' USB2ISPݿϴܵ
	Public Const mPipeDataDown As Short = &H7s ' USB2ISPݿ´ܵ
	
	' ӦòӿڵĹܴ
	Public Const mFuncNoOperation As Short = &H0s ' ޲
	Public Const mFuncGetVersion As Short = &H1s ' ȡ汾
	Public Const mFuncGetConfig As Short = &H2s ' ȡUSB豸
	Public Const mFuncSetTimeout As Short = &H9s ' USBͨѶʱ
	Public Const mFuncSetExclusive As Short = &HBs ' öռʹ
	Public Const mFuncResetDevice As Short = &HCs ' λUSB豸
	Public Const mFuncResetPipe As Short = &HDs ' λUSBܵ
	Public Const mFuncAbortPipe As Short = &HEs ' ȡUSBܵ
	
	' USB2ISPרõĹܴ
	Public Const mFuncSetParaMode As Short = &HFs ' òģʽ
	Public Const mFuncReadData0 As Short = &H10s ' Ӳڶȡݿ0
	Public Const mFuncReadData1 As Short = &H11s ' Ӳڶȡݿ1
	Public Const mFuncWriteData0 As Short = &H12s ' 򲢿дݿ0
	Public Const mFuncWriteData1 As Short = &H13s ' 򲢿дݿ1
	Public Const mFuncWriteRead As Short = &H14s ' 
	
	
	' USB豸׼
	Public Const mUSB_CLR_FEATURE As Short = &H1s
	Public Const mUSB_SET_FEATURE As Short = &H3s
	Public Const mUSB_GET_STATUS As Short = &H0s
	Public Const mUSB_SET_ADDRESS As Short = &H5s
	Public Const mUSB_GET_DESCR As Short = &H6s
	Public Const mUSB_SET_DESCR As Short = &H7s
	Public Const mUSB_GET_CONFIG As Short = &H8s
	Public Const mUSB_SET_CONFIG As Short = &H9s
	Public Const mUSB_GET_INTERF As Short = &HAs
	Public Const mUSB_SET_INTERF As Short = &HBs
	Public Const mUSB_SYNC_FRAME As Short = &HCs
	
	' USB2ISPƴĳר
	Public Const mUSBIO_VENDOR_READ As Short = &HC0s ' ͨƴʵֵUSB2ISPרö
	Public Const mUSBIO_VENDOR_WRITE As Short = &H40s ' ͨƴʵֵUSB2ISPרд
	
	' USB2ISPƴĳר
	Public Const mUSBIO_PARA_INIT As Short = &HB1s ' ʼ
	Public Const mUSBIO_I2C_STATUS As Short = &H52s ' ȡI2Cӿڵ״̬
	Public Const mUSBIO_I2C_COMMAND As Short = &H53s ' I2Cӿڵ
	
	
	Public Const mUSBIOA_CMD_I2C_STM_STA As Short = &H74s ' I2Cӿڵ:ʼλ
	Public Const mUSBIOA_CMD_I2C_STM_STO As Short = &H75s ' I2Cӿڵ:ֹͣλ
	Public Const mUSBIOA_CMD_I2C_STM_OUT As Short = &H0s 'I2Cӿڵ:,λ5-λ0Ϊ,ֽΪ,0ֻһֽڲӦ
	Public Const mUSBIOA_CMD_I2C_STM_IN As Short = &HC0s ' I2Cӿڵ:,λ5-λ0Ϊ,0ֻһֽڲӦ
	Public Const mUSBIOA_CMD_I2C_STM_SET As Short = &H60s ' I2Cӿڵ:ò,λ2=SPII/O(0=뵥,1=˫˫),λ1λ0=I2Cٶ(00=,01=׼,10=,11=)
	Public Const mUSBIOA_CMD_I2C_STM_US As Short = &H40s ' I2Cӿڵ:΢Ϊλʱ,λ3-λ0Ϊʱֵ
	Public Const mUSBIOA_CMD_I2C_STM_MS As Short = &H50s ' I2Cӿڵ:Ϊλʱ,λ3-λ0Ϊʱֵ
	Public Const mUSBIOA_CMD_I2C_STM_DLY As Short = &HFs ' I2Cӿڵʱֵ
	Public Const mUSBIOA_CMD_I2C_STM_END As Short = &H0s ' I2Cӿڵ:ǰ
	
	
	' ֱ״̬źŵλ
	Public Const mStateBitERR As Short = &H100s ' ֻ,ERR#״̬,1:ߵƽ,0:͵ƽ
	Public Const mStateBitPEMP As Short = &H200s ' ֻ,PEMP״̬,1:ߵƽ,0:͵ƽ
	Public Const mStateBitINT As Short = &H400s ' ֻ,INT#״̬,1:ߵƽ,0:͵ƽ
	Public Const mStateBitSLCT As Short = &H800s ' ֻ,SLCT״̬,1:ߵƽ,0:͵ƽ
	Public Const mStateBitSDA As Integer = &H800000 ' ֻ,SDA״̬,1:ߵƽ,0:͵ƽ
	
	
	
	
	Declare Function USBIO_OpenDevice Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Integer
	' USB2ISP豸,ؾ,Ч
	' iIndex  ָUSB2ISP豸,0Ӧһ豸
	
	Declare Sub USBIO_CloseDevice Lib "USBIOX.DLL" (ByVal iIndex As Integer)
	' رUSB2ISP豸
	' iIndex    ָUSB2ISP豸
	
	Declare Function USBIO_GetVersion Lib "USBIOX.DLL" () As Integer
	
	' DLL汾,ذ汾
	
	'UPGRADE_WARNING: ṹ WIN32_COMMAND ҪʹΪ Declare еĲݡ ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"
	Declare Function USBIO_DriverCommand Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef ioCommand As WIN32_COMMAND) As Integer
	' ֱӴ,򷵻0,򷵻ݳ
	' iIndex,  ' ָUSB2ISP豸,V1.6DLLҲ豸򿪺ľ
	' ioCommand   ṹĵַ
	' óڵú󷵻ݳ,Ȼṹ,Ƕ,ݷṹ,
	' صݳڲʧʱΪ0,ɹʱΪṹĳ,һֽ,򷵻mWIN32_COMMAND_HEAD+1,
	' ṹڵǰ,ֱṩ:ܵŻܴ,ȡݵĳ(ѡ),(ѡ)
	' ṹڵú,ֱ𷵻:״̬,ݵĳ(ѡ),
	'   ״̬WINDOWSĴ,ԲοNTSTATUS.H,
	'   ݵĳָصݳ,ݴĻ,дһΪ0
	
	Declare Function USBIO_GetDrvVersion Lib "USBIOX.DLL" () As Integer
	
	' 汾,ذ汾,򷵻0
	
	Declare Function USBIO_ResetDevice Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Boolean
	
	'λUSB豸
	' iIndex  ָUSB2ISP豸
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_GetDeviceDescr Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	' ȡ豸
	' iIndex,   ָUSB2ISP豸
	' oBuffer   ָһ㹻Ļ,ڱ
	' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_GetConfigDescr Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	' ȡ
	'  iIndex,    ָUSB2ISP豸
	'  oBuffer,   ָһ㹻Ļ,ڱ
	'  ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	Declare Function USBIO_SetIntRoutine Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iIntRoutine As Integer) As Boolean
	'趨жϷ
	' ָUSB2ISP豸
	'ָжϷ,ΪNULLȡжϷ,жʱøó
	
	
	Declare Function USBIO_ReadInter Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iStatus As Integer) As Boolean
	' ȡж
	' iIndex,  ָUSB2ISP豸
	' iStatus   ָһ˫ֵԪ,ڱȡж״̬,
	' λ7-λ0ӦUSB2ISPD7-D0
	'  λ8ӦUSB2ISPERR#, λ9ӦUSB2ISPPEMP, λ10ӦUSB2ISPINT#, λ11ӦUSB2ISPSLCT
	
	Declare Function USBIO_AbortInter Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Boolean
	' жݶ
	' iIndex   ָUSB2ISP豸
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_ReadData0 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	' 0#˿ڶȡݿ
	' iIndex     ָUSB2ISP豸
	' oBuffer   ָһ㹻Ļ,ڱȡ
	' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_ReadData1 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	' 1#˿ڶȡݿ
	' iIndex,  ָUSB2ISP豸
	' oBuffer ָһ㹻Ļ,ڱȡ
	' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	Declare Function USBIO_AbortRead Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Boolean
	' ݿ
	' iIndex    ָUSB2ISP豸
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_WriteData0 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iBuffer As Any, ByRef ioLength As Integer) As Boolean
	' 0#˿дݿ
	' iIndex,    ָUSB2ISP豸
	' iBuffer     ָһ,׼д
	' ioLength  ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_WriteData1 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iBuffer As Any, ByRef ioLength As Integer) As Boolean
	' 1#˿дݿ
	' iIndex,    ָUSB2ISP豸
	' iBuffer,    ָһ,׼д
	' ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
	
	Declare Function USBIO_AbortWrite Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Boolean
	' ݿд
	' iIndex   ָUSB2ISP豸
	
	Declare Function USBIO_GetStatus Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iStatus As Integer) As Boolean
	'  ͨUSB2ISPֱݺ״̬
	'  iIndex,   ָUSB2ISP豸
	'  iStatus  ָһ˫ֵԪ,ڱ״̬,
	'  λ7-λ0ӦUSB2ISPD7-D0
	'  λ8ӦUSB2ISPERR#, λ9ӦUSB2ISPPEMP, λ10ӦUSB2ISPINT#, λ11ӦUSB2ISPSLCT, λ23ӦUSB2ISPSDA
	'  λ13ӦUSB2ISPBUSY/WAIT#, λ14ӦUSB2ISPAUTOFD#/DATAS#,λ15ӦUSB2ISPSLCTIN#/ADDRS#
	
	Declare Function USBIO_ReadI2C Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iDevice As Byte, ByVal iAddr As Byte, ByRef oByte As Byte) As Boolean
	
	'  I2Cӿڶȡһֽ
	'  iIndex,   ָUSB2ISP豸
	'  iDevice,    7λָI2C豸ַ
	'  iAddr,    ָݵԪĵַ
	'  oByte    ָһֽڵԪ,ڱȡֽ
	
	Declare Function USBIO_WriteI2C Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iDevice As Byte, ByVal iAddr As Byte, ByVal iByte As Byte) As Boolean
	
	'    I2Cӿдһֽ
	'    iIndex,   ָUSB2ISP豸
	'    iDevice,   7λָI2C豸ַ
	'    iAddr,  ָݵԪĵַ
	'    iByte  дֽ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_EppReadData Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	'  EPPʽ: WR#=1, DS#=0, AS#=1, D0-D7=input
	'  iIndex,    ָUSB2ISP豸
	'  oBuffer,    ָһ㹻Ļ,ڱȡ
	'  ioLength    ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_EppReadAddr Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	'  EPPʽַ: WR#=1, DS#=1, AS#=0, D0-D7=input
	'  iIndex,    ָUSB2ISP豸
	'  oBuffer,    ָһ㹻Ļ,ڱȡĵַ
	'  ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_EppWriteData Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iBuffer As Any, ByRef ioLength As Integer) As Boolean
	'   EPPʽд: WR#=0, DS#=0, AS#=1, D0-D7=output
	'   iIndex,     ָUSB2ISP豸
	'   iBuffer,    ָһ,׼д
	'   ioLength     ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_EppWriteAddr Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iBuffer As Any, ByRef ioLength As Integer) As Boolean
	'   EPPʽдַ: WR#=0, DS#=1, AS#=0, D0-D7=output
	'   iIndex,    ָUSB2ISP豸
	'   iBuffer,    ָһ,׼дĵַ
	'   ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_MemReadAddr0 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	' MEMʽַ0: WR#=1, DS#/RD#=0, AS#/ADDR=0, D0-D7=input
	' iIndex,    ָUSB2ISP豸
	' oBuffer,     ָһ㹻Ļ,ڱӵַ0ȡ
	' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_MemReadAddr1 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	' MEMʽַ1: WR#=1, DS#/RD#=0, AS#/ADDR=1, D0-D7=input
	' iIndex,    ָUSB2ISP豸
	' oBuffer,    ָһ㹻Ļ,ڱӵַ1ȡ
	' ioLength    ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_MemWriteAddr0 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iBuffer As Any, ByRef ioLength As Integer) As Boolean
	' MEMʽдַ0: WR#=0, DS#/RD#=1, AS#/ADDR=0, D0-D7=output
	' iIndex,    ָUSB2ISP豸
	' iBuffer,    ָһ,׼ַ0д
	' ioLength    ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_MemWriteAddr1 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iBuffer As Any, ByRef ioLength As Integer) As Boolean
	'  MEMʽдַ1: WR#=0, DS#/RD#=1, AS#/ADDR=1, D0-D7=output
	'  iIndex,   ָUSB2ISP豸
	'  iBuffer,    ָһ,׼ַ1д
	'  ioLength      ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
	
	Declare Function USBIO_SetExclusive Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iExclusive As Integer) As Boolean
	' öռʹõǰUSB2ISP豸
	' iIndex,    ָUSB2ISP豸
	' iExclusive  Ϊ0豸Թʹ,0ռʹ
	
	Declare Function USBIO_SetTimeout Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iWriteTimeout As Integer, ByVal iReadTimeout As Integer) As Boolean
	'  USBݶдĳʱ
	'  iIndex,  // ָUSB2ISP豸
	'  iWriteTimeout  ָUSBдݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
	'  iReadTimeout  ָUSBȡݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_ReadData Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef oBuffer As Any, ByRef ioLength As Integer) As Boolean
	' ȡݿ
	' iIndex,    ָUSB2ISP豸
	' oBuffer,    ָһ㹻Ļ,ڱȡ
	' ioLength      ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_WriteData Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iBuffer As Any, ByRef ioLength As Integer) As Boolean
	'  дݿ
	'  iIndex,    ָUSB2ISP豸
	'  iBuffer,    ָһ,׼д
	'  ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
	
	Declare Function USBIO_GetDeviceName Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Integer ''''
	' ָUSB2ISP豸ƵĻ,򷵻NULL
	' iIndex   ָUSB2ISP豸,0Ӧһ豸
	
	Declare Function USBIO_FlushBuffer Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Boolean
	' USB2ISPĻ
	' iIndex   ָUSB2ISP豸
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_WriteRead Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iWriteLength As Integer, ByRef iWriteBuffer As Any, ByVal iReadStep As Integer, ByVal iReadTimes As Integer, ByRef oReadLength As Integer, ByRef oReadBuffer As Any) As Boolean
	' USBIO_WriteRead   ִ,
	' iIndex,    ָUSB2ISP豸
	' iWriteLength,   д,׼дĳ
	' iWriteBuffer,    ָһ,׼д
	' iReadStep,    ׼ȡĵĳ, ׼ȡܳΪ(iReadStep*iReadTimes)
	' iReadTimes,    ׼ȡĴ
	' oReadLength,    ָ򳤶ȵԪ,غΪʵʶȡĳ
	' oReadBuffer      ָһ㹻Ļ,ڱȡ
	
	Declare Function USBIO_SetStream Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iMode As Integer) As Boolean
	' USBIO_SetStream   ôģʽ
	' iIndex,    ָUSB2ISP豸
	' iMode      ָģʽ,
	' λ1-λ0: I2Cӿٶ/SCLƵ, 00=/20KHz,01=׼/100KHz,10=/400KHz,11=/750KHz
	' λ2:     SPII/O/IO, 0=뵥(D5/D7),1=˫˫(D5D4/D7D6)
	' λ7:     SPIֽеλ˳, 0=λǰ, 1=λǰ
	' ,Ϊ0
	
	Declare Function USBIO_SetDelaymS Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iDelay As Integer) As Boolean
	'  USBIO_SetDelaymS     Ӳ첽ʱ,úܿ췵,һ֮ǰʱָ
	' iIndex,    ָUSB2ISP豸
	' iDelay      ָʱĺ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_StreamI2C Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iWriteLength As Integer, ByRef iWriteBuffer As Any, ByVal iReadLength As Integer, ByRef oReadBuffer As Any) As Boolean
	' USBIO_StreamI2C     I2C,2߽ӿ,ʱΪSCL,ΪSDA(׼˫I/O),ٶԼ56Kֽ
	' iIndex,    ָUSB2ISP豸
	' iWriteLength,    ׼дֽ
	' iWriteBuffer,    ָһ,׼д,ֽͨI2C豸ַдλ
	' iReadLength,     ׼ȡֽ
	' oReadBuffer     ָһ,غǶ
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	'UPGRADE_WARNING: ṹ EEPROM_TYPE ҪʹΪ Declare еĲݡ ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"
	Declare Function USBIO_ReadEEPROM Lib "USBIOX.DLL" (ByVal iIndexas As Integer, ByVal iEepromID As EEPROM_TYPE, ByVal iAddr As Integer, ByVal iLength As Integer, ByRef oBuffer As Any) As Boolean
	' i    Index  ָUSB2ISP豸
	' iEepromID   ָEEPROMͺ
	' iAddr       ָݵԪĵַ
	' iLength     ׼ȡֽ
	' oBuffer     ָһ,غǶ
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	'UPGRADE_WARNING: ṹ EEPROM_TYPE ҪʹΪ Declare еĲݡ ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"
	Declare Function USBIO_WriteEEPROM Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iEepromID As EEPROM_TYPE, ByVal iAddr As Integer, ByVal iLength As Integer, ByRef iBuffer As Any) As Boolean
	' iIndex,    ָUSB2ISP豸
	' iEepromID, ָEEPROMͺ
	' iAddr,     ָݵԪĵַ
	' iLength,   ׼дֽ
	' iBuffer    ָһ,׼д
	'----------------------------------------------------------------------------------------
	Declare Function USBIO_GetInput Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iStatus As Integer) As Boolean
	' USBIO_GetInput ͨUSB2ISPֱݺ״̬,ЧʱUSBIO_GetStatus
	' iIndex,  ָUSB2ISP豸
	' iStatus  ָһ˫ֵԪ,ڱ״̬,ολ˵
	' λ7-λ0ӦUSB2ISPD7-D0
	' λ8ӦUSB2ISPERR#, λ9ӦUSB2ISPPEMP, λ10ӦUSB2ISPINT#, λ11ӦUSB2ISPSLCT, λ23ӦUSB2ISPSDA
	' λ13ӦUSB2ISPBUSY/WAIT#, λ14ӦUSB2ISPAUTOFD#/DATAS#,λ15ӦUSB2ISPSLCTIN#/ADDRS#
	
	Declare Function USBIO_SetOutput Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iEnable As Integer, ByVal iSetDirOut As Integer, ByVal iSetDataOut As Integer) As Boolean
	' USBIO_SetOutput USB2ISPI/O,ͨUSBIO_ֱ
	' ***** ʹøAPI, ֹ޸I/OʹűΪŵ֮·оƬ *****
	' iIndex,  ָUSB2ISP豸
	' iEnable, Ч־,ολ˵
	'// λ0Ϊ1˵iSetDataOutλ15-λ8Ч,
	'// λ1Ϊ1˵iSetDirOutλ15-λ8Ч,
	'// λ2Ϊ1˵iSetDataOut7-λ0Ч,
	'// λ3Ϊ1˵iSetDirOutλ7-λ0Ч,
	'// λ4Ϊ1˵iSetDataOutλ23-λ16Ч,
	' iSetDirOut, I/O,ĳλ0ӦΪ,ĳλ1ӦΪ,ڷʽĬֵΪ0x000FC000,ολ˵
	' iSetDataOut ,I/OΪ,ôĳλ0ʱӦ͵ƽ,ĳλ1ʱӦߵƽ,ολ˵
	'// λ7-λ0ӦUSB2ISPD7-D0
	'// λ8ӦUSB2ISPERR#, λ9ӦUSB2ISPPEMP, λ10ӦUSB2ISPINT#, λ11ӦUSB2ISPSLCT
	'// λ13ӦUSB2ISPWAIT#, λ14ӦUSB2ISPDATAS#/READ#,λ15ӦUSB2ISPADDRS#/ADDR/ALE
	'// ֻ,I/O: λ16ӦUSB2ISPRESET#, λ17ӦUSB2ISPWRITE#, λ18ӦUSB2ISPSCL, λ29ӦUSB2ISPSDA
	
	Declare Function USBIO_Set_D5_D0 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iSetDirOut As Integer, ByVal iSetDataOut As Integer) As Boolean
	' USBIO_Set_D5_D0 USB2ISPD5-D0ŵI/O,ͨUSB2ISPD5-D0ֱ,ЧʱUSBIO_SetOutput
	' ***** ʹøAPI, ֹ޸I/OʹűΪŵ֮·оƬ *****
	' iIndex,      ָUSB2ISP豸
	' iSetDirOut,  D5-D0ŵI/O,ĳλ0ӦΪ,ĳλ1ӦΪ,ڷʽĬֵΪ0x00ȫ
	' iSetDataOut  D5-D0ŵ,I/OΪ,ôĳλ0ʱӦ͵ƽ,ĳλ1ʱӦߵƽ
	'// ݵλ5-λ0ֱӦUSB2ISPD5-D0
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_StreamSPI3 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iChipSelect As Integer, ByVal iLength As Integer, ByRef ioBuffer As Any) As Boolean
	' USBIO_StreamSPI3 SPI,3߽ӿ,ʱΪSCK/SCL,ΪDIO/SDA(׼˫I/O),ƬѡΪD0/D1/D2,ٶԼ51Kֽ
	' SPIʱ: SCK2/SCLΪʱ, ĬΪ͵ƽ, DIO/SDAʱ֮ǰ, DIO/SDAʱ½֮
	' iIndex,   ָUSB2ISP豸
	' iChipSelect,Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
	' iLength,    ׼ֽ
	' ioBuffer    ָһ,׼DIOд,غǴDIO
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_StreamSPI4 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iChipSelect As Integer, ByVal iLength As Integer, ByRef ioBuffer As Any) As Boolean
	' USBIO_StreamSPI4 SPI,4߽ӿ,ʱΪSCK/D3,ΪDOUT/D5/MOSI,ΪDIN/D7/MISO,ƬѡΪD0/D1/D2,ٶԼ68Kֽ
	' SPIʱ: SCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5/MOSIʱ֮ǰ, DIN/D7/MISOʱ½֮
	' iIndex,   ָUSB2ISP豸
	' iChipSelect,Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
	' iLength,    ׼ֽ
	' ioBuffer    ָһ,׼DOUT/MOSIд,غǴDIN/MISO
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_StreamSPI5 Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iChipSelect As Integer, ByVal iLength As Integer, ByRef ioBuffer As Any, ByRef ioBuffer2 As Any) As Boolean
	' USBIO_StreamSPI5 SPI,5߽ӿ,ʱΪSCK/D3,ΪDOUT/D5/MOSIDOUT2/D4,ΪDIN/D7/MISODIN2/D6,ƬѡΪD0/D1/D2,ٶԼ30Kֽ*2
	' SPIʱ: SCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5/MOSIDOUT2/D4ʱ֮ǰ, DIN/D7/MISODIN2/D6ʱ½֮
	' iIndex,   ָUSB2ISP豸
	' iChipSelect,Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
	' iLength,    ׼ֽ
	' ioBuffer,   ָһ,׼DOUT/MOSIд,غǴDIN/MISO
	' ioBuffer2   ָڶ,׼DOUT/MOSI2д,غǴDIN/MISO2
	
	'UPGRADE_ISSUE: ֽ֧ΪAs Any ԻøϢ:ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"
	Declare Function USBIO_BitStreamSPI Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iLength As Integer, ByRef ioBuffer As Any) As Boolean
	' USBIO_BitStreamSPI SPIλ,4/5߽ӿ,ʱΪSCK/D3,ΪDOUT/DOUT2,ΪDIN/DIN2,ƬѡΪD0/D1/D2,ٶԼ8Kλ*2
	' iIndex,  ָUSB2ISP豸
	' iLength, ׼λ,һ896,鲻256
	' ioBuffer ָһ,׼DOUT/MOSI/DOUT2/D2-D0д,غǴDIN/MISO/DIN2
	'/* SPIʱ: SCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5/MOSIDOUT2/D4ʱ֮ǰ, DIN/D7/MISODIN2/D6ʱ½֮ */
	'/* ioBufferеһֽڹ8λֱӦD7-D0, λ5DOUT, λ4DOUT2, λ2-λ0D2-D0, λ7DIN/MISO, λ6DIN/MISO2, λ3ݺ */
	'/* ڵøAPI֮ǰ,ӦȵUSBIO_Set_D5_D0USB2ISPD5-D0ŵI/O,ŵĬϵƽ */
	
	'-------------------------------------------------------------------------
	
	Declare Function USBIO_SetBufUpload Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iEnableOrClear As Integer) As Boolean ' Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
	' USBIO_SetBufUpload  ' 趨ڲϴģʽ
	' iIndex,          0ָUSB2ISP豸,0Ӧһ豸
	' iEnableOrClear  Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
	' ڲϴģʽ,ôUSB2ISP򴴽߳ԶUSBϴݵڲ,ͬʱе,ӦóUSBIO_ReadDataػе
	
	Declare Function USBIO_QueryBufUpload Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Integer
	' USBIO_QueryBufUpload   ѯڲϴеݰ,ɹݰ,-1
	' iIndex                ָUSB2ISP豸,0Ӧһ豸
	
	Declare Function USBIO_SetBufDownload Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByVal iEnableOrClear As Integer) As Boolean
	'  USBIO_SetBufDownload  趨ڲ´ģʽ
	'  iIndex,              ָUSB2ISP豸,0Ӧһ豸
	'  iEnableOrClear       Ϊ0ֹڲ´ģʽ,ʹֱ´,0ڲ´ģʽе
	'  ڲ´ģʽ,ôӦóUSBIO_WriteData󽫽ǽUSB´ݷŵڲ,USB2ISP򴴽߳Զֱ
	
	Declare Function USBIO_QueryBufDownload Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Integer ' ָUSB2ISP豸,0Ӧһ豸
	'  USBIO_QueryBufDownload  ѯڲ´еʣݰ(δ),ɹݰ,-1
	'  iIndex                 ָUSB2ISP豸,0Ӧһ豸
	
	
	Declare Function USBIO_ResetInter Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Boolean
	'  USBIO_ResetInter   λжݶ
	'  iIndex            ָUSB2ISP豸
	
	Declare Function USBIO_ResetRead Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Boolean
	'  USBIO_ResetRead  λݿ
	'  iIndex          ָUSB2ISP豸
	
	Declare Function USBIO_ResetWrite Lib "USBIOX.DLL" (ByVal iIndex As Integer) As Boolean
	'    USBIO_ResetRead    λݿ
	'    iIndex            ָUSB2ISP豸
	
	'typedef     VOID    ( CALLBACK  * mUSBIO_NOTIFY_ROUTINE ) (  ' 豸¼֪ͨص
	'    ULONG           iEventStatus );  ' 豸¼͵ǰ״̬(ж): 0=豸γ¼, 3=豸¼
	
	Public Const USBIO_DEVICE_ARRIVAL As Short = 3 ' 豸¼,Ѿ
	Public Const USBIO_DEVICE_REMOVE_PEND As Short = 1 ' 豸Ҫγ
	Public Const USBIO_DEVICE_REMOVE As Short = 0 ' 豸γ¼,Ѿγ
	
	Declare Function USBIO_SetDeviceNotify Lib "USBIOX.DLL" (ByVal iIndex As Integer, ByRef iDeviceID As String, ByVal iNotifyRoutine As Integer) As Boolean
	'  USBIO_SetDeviceNotify     趨豸¼֪ͨ
	'  iIndex,                  ָUSB2ISP豸,0Ӧһ豸
	'  iDeviceID,               ѡ,ַָ,ָص豸ID,ַ\0ֹ
	'  iNotifyRoutine           (ַ)ָ豸¼ص, ΪNULLȡ¼֪ͨ, ڼ⵽¼ʱøó
End Module