// 2005.03.25, 2005.04.28, 2005.07.18, 
// 2005.07.28, 2005.09.19, 2006.06.08
//****************************************
//**  Copyright  (C)  USBIO  1999-2005  **
//**  WEB:  http://WWW.USB-I2C-SPI.COM  **
//****************************************
//**  DLL for USB interface chip USB2ISP**
//**  C, VC5.0                          **
//****************************************
//
// USBӿоƬUSB2ISPӦòӿڿ V1.9
// USBIO TECH.       : USBIO  2006.08
// USBIOX.DLL  V1.9
// л: Windows 98/ME, Windows 2000/XP
// USB <=> I2C @40KHZ,100KHZ,400KHZ,75KHZ.
//

#ifndef		_mUSBIOX_DLL_H
#define		_mUSBIOX_DLL_H

#ifdef __cplusplus
extern "C" {
#endif

#define		mOFFSET( s, m )			( (ULONG) & ( ( ( s * ) 0 ) -> m ) )	// ȡṹԱƫƵַĺ

#ifndef		max
#define		max( a, b )				( ( ( a ) > ( b ) ) ? ( a ) : ( b ) )	// ϴֵ
#endif

#ifndef		min
#define		min( a, b )				( ( ( a ) < ( b ) ) ? ( a ) : ( b ) )	// Сֵ
#endif

#ifdef		ExAllocatePool
#undef		ExAllocatePool						// ɾTAGڴ
#endif

#ifndef		NTSTATUS
typedef		LONG	NTSTATUS;					// ״̬
#endif


typedef	struct	_USB_SETUP_PKT {				// USBƴĽ׶εṹ
	UCHAR			mUspReqType;				// 00H 
	UCHAR			mUspRequest;				// 01H 
	union	{
		struct	{
			UCHAR	mUspValueLow;				// 02H ֵֽ
			UCHAR	mUspValueHigh;				// 03H ֵֽ
		};
		USHORT		mUspValue;					// 02H-03H ֵ
	};
	union	{
		struct	{
			UCHAR	mUspIndexLow;				// 04H ֽ
			UCHAR	mUspIndexHigh;				// 05H ֽ
		};
		USHORT		mUspIndex;					// 04H-05H 
	};
	USHORT			mLength;					// 06H-07H ݽ׶εݳ
} mUSB_SETUP_PKT, *mPUSB_SETUP_PKT;


//#define		mmUSBIO_PACKET_LENGTH_PACKET_LENGTH	32			// mUSBIO_PACKET_LENGTHֵ֧ݰĳ
//#define		mmUSBIO_PACKET_LENGTH_PKT_LEN_SHORT	8			// mUSBIO_PACKET_LENGTHֵ֧Ķݰĳ
#define		mUSBIO_PACKET_LENGTH	32			// USB2ISPֵ֧ݰĳ
#define		mUSBIO_PKT_LEN_SHORT	8			// USB2ISPֵ֧Ķݰĳ


typedef	struct	_WIN32_COMMAND {				// WIN32ӿڽṹ
	union	{
		ULONG		mFunction;					// ʱָܴ߹ܵ
		NTSTATUS	mStatus;					// ʱز״̬
	};
	ULONG			mLength;					// ȡ,غݵĳ
	union	{
		mUSB_SETUP_PKT	mSetupPkt;				// USBƴĽ׶ε
		UCHAR			mBuffer[ mUSBIO_PACKET_LENGTH ];	// ݻ,Ϊ0255B
	};
} mWIN32_COMMAND, *mPWIN32_COMMAND;


// WIN32Ӧòӿ
#define		IOCTL_mUSBIO_PACKET_LENGTH_COMMAND		( FILE_DEVICE_UNKNOWN << 16 | FILE_ANY_ACCESS << 14 | 0x0f34 << 2 | METHOD_BUFFERED )	// רýӿ

#define		mWIN32_COMMAND_HEAD		mOFFSET( mWIN32_COMMAND, mBuffer )	// WIN32ӿڵͷ

#define		mmUSBIO_PACKET_LENGTH_MAX_NUMBER		16			// ͬʱӵmUSBIO_PACKET_LENGTH

#define		mMAX_BUFFER_LENGTH		0x1000		// ݻ󳤶4096

#define		mMAX_COMMAND_LENGTH		( mWIN32_COMMAND_HEAD + mMAX_BUFFER_LENGTH )	// ݳȼṹͷĳ

#define		mDEFAULT_BUFFER_LEN		0x0400		// ݻĬϳ1024

#define		mDEFAULT_COMMAND_LEN	( mWIN32_COMMAND_HEAD + mDEFAULT_BUFFER_LEN )	// Ĭݳȼṹͷĳ


// mUSBIO_PACKET_LENGTH˵ַ
#define		mmUSBIO_PACKET_LENGTH_ENDP_INTER_UP	0x81		// mUSBIO_PACKET_LENGTHжϴ˵ĵַ
#define		mmUSBIO_PACKET_LENGTH_ENDP_INTER_DOWN	0x01		// mUSBIO_PACKET_LENGTHж´˵ĵַ
#define		mmUSBIO_PACKET_LENGTH_ENDP_DATA_UP		0x82		// mUSBIO_PACKET_LENGTHݿϴ˵ĵַ
#define		mmUSBIO_PACKET_LENGTH_ENDP_DATA_DOWN	0x02		// mUSBIO_PACKET_LENGTHݿ´˵ĵַ


// 豸ӿṩĹܵ
#define		mPipeDeviceCtrl			0x00000004	// mUSBIO_PACKET_LENGTHۺϿƹܵ
#define		mPipeInterUp			0x00000005	// mUSBIO_PACKET_LENGTHжϴܵ
#define		mPipeDataUp				0x00000006	// mUSBIO_PACKET_LENGTHݿϴܵ
#define		mPipeDataDown			0x00000007	// mUSBIO_PACKET_LENGTHݿ´ܵ

// ӦòӿڵĹܴ
#define		mFuncNoOperation		0x00000000	// ޲
#define		mFuncGetVersion			0x00000001	// ȡ汾
#define		mFuncGetConfig			0x00000002	// ȡUSB豸
#define		mFuncSetTimeout			0x00000009	// USBͨѶʱ
#define		mFuncSetExclusive		0x0000000b	// öռʹ
#define		mFuncResetDevice		0x0000000c	// λUSB豸
#define		mFuncResetPipe			0x0000000d	// λUSBܵ
#define		mFuncAbortPipe			0x0000000e	// ȡUSBܵ

// mUSBIO_PACKET_LENGTHרõĹܴ
#define		mFuncSetParaMode		0x0000000f	// òģʽ
#define		mFuncReadData0			0x00000010	// Ӳڶȡݿ0
#define		mFuncReadData1			0x00000011	// Ӳڶȡݿ1
#define		mFuncWriteData0			0x00000012	// 򲢿дݿ0
#define		mFuncWriteData1			0x00000013	// 򲢿дݿ1
#define		mFuncWriteRead			0x00000014	// 
#define		mFuncBufferMode			0x00000020	// 趨ϴģʽѯеݳ
#define		mFuncBufferModeDn		0x00000021	// 趨´ģʽѯеݳ


// USB豸׼
#define		mUSB_CLR_FEATURE		0x01
#define		mUSB_SET_FEATURE		0x03
#define		mUSB_GET_STATUS			0x00
#define		mUSB_SET_ADDRESS		0x05
#define		mUSB_GET_DESCR			0x06
#define		mUSB_SET_DESCR			0x07
#define		mUSB_GET_CONFIG			0x08
#define		mUSB_SET_CONFIG			0x09
#define		mUSB_GET_INTERF			0x0a
#define		mUSB_SET_INTERF			0x0b
#define		mUSB_SYNC_FRAME			0x0c

// mUSBIO_PACKET_LENGTHƴĳר
#define		mmUSBIO_PACKET_LENGTH_VENDOR_READ		0xC0		// ͨƴʵֵmUSBIO_PACKET_LENGTHרö
#define		mmUSBIO_PACKET_LENGTH_VENDOR_WRITE		0x40		// ͨƴʵֵmUSBIO_PACKET_LENGTHרд

// mUSBIO_PACKET_LENGTHƴĳר
#define		mmUSBIO_PACKET_LENGTH_PARA_INIT		0xB1		// ʼ
#define		mmUSBIO_PACKET_LENGTH_I2C_STATUS		0x52		// ȡI2Cӿڵ״̬
#define		mmUSBIO_PACKET_LENGTH_I2C_COMMAND		0x53		// I2Cӿڵ

// mUSBIO_PACKET_LENGTHڲ
#define		mmUSBIO_PACKET_LENGTH_PARA_CMD_R0		0xAC		// Ӳڶ0
#define		mmUSBIO_PACKET_LENGTH_PARA_CMD_R1		0xAD		// Ӳڶ1
#define		mmUSBIO_PACKET_LENGTH_PARA_CMD_W0		0xA6		// 򲢿д0
#define		mmUSBIO_PACKET_LENGTH_PARA_CMD_W1		0xA7		// 򲢿д1
#define		mmUSBIO_PACKET_LENGTH_PARA_CMD_STS		0xA0		// ȡ״̬

// mUSBIO_PACKET_LENGTHAڲ
#define		mmUSBIO_PACKET_LENGTHA_CMD_SET_OUTPUT	0xA1		// ò
#define		mmUSBIO_PACKET_LENGTHA_CMD_IO_ADDR		0xA2		// MEMַд/,ӴֽڿʼΪ
#define		mmUSBIO_PACKET_LENGTHA_CMD_PRINT_OUT	0xA3		// PRINTݴӡʽ,ӴֽڿʼΪ
#define		mmUSBIO_PACKET_LENGTHA_CMD_SPI_STREAM	0xA8		// SPIӿڵ,ӴֽڿʼΪ
#define		mmUSBIO_PACKET_LENGTHA_CMD_SIO_STREAM	0xA9		// SIOӿڵ,ӴֽڿʼΪ
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STREAM	0xAA		// I2Cӿڵ,ӴֽڿʼΪI2C
#define		mmUSBIO_PACKET_LENGTHA_CMD_UIO_STREAM	0xAB		// UIOӿڵ,ӴֽڿʼΪ

// mUSBIO_PACKET_LENGTHAƴĳר
#define		mmUSBIO_PACKET_LENGTHA_BUF_CLEAR		0xB2		// δɵ
#define		mmUSBIO_PACKET_LENGTHA_I2C_CMD_X		0x54		// I2Cӿڵ,ִ
#define		mmUSBIO_PACKET_LENGTHA_DELAY_MS		0x5E		// Ϊλʱָʱ
#define		mmUSBIO_PACKET_LENGTHA_GET_VER			0x5F		// ȡоƬ汾

#define		mmUSBIO_PACKET_LENGTH_EPP_IO_MAX		( mUSBIO_PACKET_LENGTH - 1 )	// mUSBIO_PACKET_LENGTHEPP/MEMʽµζдݿ󳤶
#define		mmUSBIO_PACKET_LENGTHA_EPP_IO_MAX		0xFF		// mUSBIO_PACKET_LENGTHAEPP/MEMʽµζдݿ󳤶

#define		mmUSBIO_PACKET_LENGTHA_CMD_IO_ADDR_W	0x00		// MEMַд/:д,λ6-λ0Ϊַ,һֽΪд
#define		mmUSBIO_PACKET_LENGTHA_CMD_IO_ADDR_R	0x80		// MEMַд/:,λ6-λ0Ϊַ,һ𷵻

#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_STA	0x74		// I2Cӿڵ:ʼλ
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_STO	0x75		// I2Cӿڵ:ֹͣλ
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_OUT	0x80		// I2Cӿڵ:,λ5-λ0Ϊ,ֽΪ,0ֻһֽڲӦ
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_IN	0xC0		// I2Cӿڵ:,λ5-λ0Ϊ,0ֻһֽڲӦ
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_MAX	( min( 0x3F, mUSBIO_PACKET_LENGTH ) )	// I2Cӿڵݵ󳤶
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_SET	0x60		// I2Cӿڵ:ò,λ2=SPII/O(0=뵥,1=˫˫),λ1λ0=I2Cٶ(00=,01=׼,10=,11=)
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_US	0x40		// I2Cӿڵ:΢Ϊλʱ,λ3-λ0Ϊʱֵ
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_MS	0x50		// I2Cӿڵ:Ϊλʱ,λ3-λ0Ϊʱֵ
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_DLY	0x0F		// I2Cӿڵʱֵ
#define		mmUSBIO_PACKET_LENGTHA_CMD_I2C_STM_END	0x00		// I2Cӿڵ:ǰ

#define		mmUSBIO_PACKET_LENGTHA_CMD_UIO_STM_IN	0x00		// UIOӿڵ:D7-D0
#define		mmUSBIO_PACKET_LENGTHA_CMD_UIO_STM_DIR	0x40		// UIOӿڵ:趨I/OD5-D0,λ5-λ0Ϊ
#define		mmUSBIO_PACKET_LENGTHA_CMD_UIO_STM_OUT	0x80		// UIOӿڵ:D5-D0,λ5-λ0Ϊ
#define		mmUSBIO_PACKET_LENGTHA_CMD_UIO_STM_US	0xC0		// UIOӿڵ:΢Ϊλʱ,λ5-λ0Ϊʱֵ
#define		mmUSBIO_PACKET_LENGTHA_CMD_UIO_STM_END	0x20		// UIOӿڵ:ǰ


// mUSBIO_PACKET_LENGTHڹģʽ
#define		mmUSBIO_PACKET_LENGTH_PARA_MODE_EPP	0x00		// mUSBIO_PACKET_LENGTHڹģʽΪEPPʽ
#define		mmUSBIO_PACKET_LENGTH_PARA_MODE_EPP17	0x00		// mUSBIO_PACKET_LENGTHAڹģʽΪEPPʽV1.7
#define		mmUSBIO_PACKET_LENGTH_PARA_MODE_EPP19	0x01		// mUSBIO_PACKET_LENGTHAڹģʽΪEPPʽV1.9
#define		mmUSBIO_PACKET_LENGTH_PARA_MODE_MEM	0x02		// mUSBIO_PACKET_LENGTHڹģʽΪMEMʽ


// I/Oλ,ֱ״̬źŵλ,ֱλݶ
#define		mStateBitERR			0x00000100	// ֻд,ERR#״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitPEMP			0x00000200	// ֻд,PEMP״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitINT			0x00000400	// ֻд,INT#״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitSLCT			0x00000800	// ֻд,SLCT״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitWAIT			0x00002000	// ֻд,WAIT#״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitDATAS			0x00004000	// ֻдɶ,DATAS#/READ#״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitADDRS			0x00008000	// ֻдɶ,ADDRS#/ADDR/ALE״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitRESET			0x00010000	// ֻд,RESET#״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitWRITE			0x00020000	// ֻд,WRITE#״̬,1:ߵƽ,0:͵ƽ
#define		mStateBitSDA			0x00800000	// ֻ,SDA״̬,1:ߵƽ,0:͵ƽ


#define		MAX_DEVICE_PATH_SIZE	128			// 豸Ƶַ
#define		MAX_DEVICE_ID_SIZE		64			// 豸IDַ


typedef		VOID	( CALLBACK	* mPmUSBIO_PACKET_LENGTH_INT_ROUTINE ) (  // жϷ
	ULONG			iStatus );  // ж״̬,ολ˵
// λ7-λ0ӦmUSBIO_PACKET_LENGTHD7-D0
// λ8ӦmUSBIO_PACKET_LENGTHERR#, λ9ӦmUSBIO_PACKET_LENGTHPEMP, λ10ӦmUSBIO_PACKET_LENGTHINT#, λ11ӦmUSBIO_PACKET_LENGTHSLCT


HANDLE	WINAPI	USBIO_OpenDevice(  // mUSBIO_PACKET_LENGTH豸,ؾ,Ч
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸,0Ӧһ豸


VOID	WINAPI	USBIO_CloseDevice(  // رmUSBIO_PACKET_LENGTH豸
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


ULONG	WINAPI	USBIO_GetVersion( );  // DLL汾,ذ汾


ULONG	WINAPI	USBIO_DriverCommand(  // ֱӴ,򷵻0,򷵻ݳ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸,V1.6DLLҲ豸򿪺ľ
	mPWIN32_COMMAND	ioCommand );  // ṹָ
// óڵú󷵻ݳ,Ȼṹ,Ƕ,ݷṹ,
// صݳڲʧʱΪ0,ɹʱΪṹĳ,һֽ,򷵻mWIN32_COMMAND_HEAD+1,
// ṹڵǰ,ֱṩ:ܵŻܴ,ȡݵĳ(ѡ),(ѡ)
// ṹڵú,ֱ𷵻:״̬,ݵĳ(ѡ),
//   ״̬WINDOWSĴ,ԲοNTSTATUS.H,
//   ݵĳָصݳ,ݴĻ,дһΪ0


ULONG	WINAPI	USBIO_GetDrvVersion( );  // 汾,ذ汾,򷵻0


BOOL	WINAPI	USBIO_ResetDevice(  // λUSB豸
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


BOOL	WINAPI	USBIO_GetDeviceDescr(  // ȡ豸
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_GetConfigDescr(  // ȡ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_SetIntRoutine(  // 趨жϷ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	mPmUSBIO_PACKET_LENGTH_INT_ROUTINE	iIntRoutine );  // ָжϷ,ΪNULLȡжϷ,жʱøó


BOOL	WINAPI	USBIO_ReadInter(  // ȡж
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PULONG			iStatus );  // ָһ˫ֵԪ,ڱȡж״̬,
// λ7-λ0ӦmUSBIO_PACKET_LENGTHD7-D0
// λ8ӦmUSBIO_PACKET_LENGTHERR#, λ9ӦmUSBIO_PACKET_LENGTHPEMP, λ10ӦmUSBIO_PACKET_LENGTHINT#, λ11ӦmUSBIO_PACKET_LENGTHSLCT


BOOL	WINAPI	USBIO_AbortInter(  // жݶ
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


BOOL	WINAPI	USBIO_SetParaMode(  // òģʽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iMode );  // ָģʽ: 0ΪEPPģʽ/EPPģʽV1.7, 1ΪEPPģʽV1.9, 2ΪMEMģʽ


BOOL	WINAPI	USBIO_InitParallel(  // λʼ,RST#͵ƽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iMode );  // ָģʽ: 0ΪEPPģʽ/EPPģʽV1.7, 1ΪEPPģʽV1.9, 2ΪMEMģʽ, >= 0x00000100 ֵǰģʽ


BOOL	WINAPI	USBIO_ReadData0(  // 0#˿ڶȡݿ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱȡ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_ReadData1(  // 1#˿ڶȡݿ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱȡ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_AbortRead(  // ݿ
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


BOOL	WINAPI	USBIO_WriteData0(  // 0#˿дݿ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			iBuffer,  // ָһ,׼д
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ


BOOL	WINAPI	USBIO_WriteData1(  // 1#˿дݿ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			iBuffer,  // ָһ,׼д
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ


BOOL	WINAPI	USBIO_AbortWrite(  // ݿд
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


BOOL	WINAPI	USBIO_GetStatus(  // ͨmUSBIO_PACKET_LENGTHֱݺ״̬
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PULONG			iStatus );  // ָһ˫ֵԪ,ڱ״̬,ολ˵
// λ7-λ0ӦmUSBIO_PACKET_LENGTHD7-D0
// λ8ӦmUSBIO_PACKET_LENGTHERR#, λ9ӦmUSBIO_PACKET_LENGTHPEMP, λ10ӦmUSBIO_PACKET_LENGTHINT#, λ11ӦmUSBIO_PACKET_LENGTHSLCT, λ23ӦmUSBIO_PACKET_LENGTHSDA
// λ13ӦmUSBIO_PACKET_LENGTHBUSY/WAIT#, λ14ӦmUSBIO_PACKET_LENGTHAUTOFD#/DATAS#,λ15ӦmUSBIO_PACKET_LENGTHSLCTIN#/ADDRS#


BOOL	WINAPI	USBIO_ReadI2C(  // I2Cӿڶȡһֽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	UCHAR			iDevice,  // 7λָI2C豸ַ
	UCHAR			iAddr,  // ָݵԪĵַ
	PUCHAR			oByte );  // ָһֽڵԪ,ڱȡֽ


BOOL	WINAPI	USBIO_WriteI2C(  // I2Cӿдһֽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	UCHAR			iDevice,  // 7λָI2C豸ַ
	UCHAR			iAddr,  // ָݵԪĵַ
	UCHAR			iByte );  // дֽ


BOOL	WINAPI	USBIO_EppReadData(  // EPPʽ: WR#=1, DS#=0, AS#=1, D0-D7=input
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱȡ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_EppReadAddr(  // EPPʽַ: WR#=1, DS#=1, AS#=0, D0-D7=input
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱȡĵַ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_EppWriteData(  // EPPʽд: WR#=0, DS#=0, AS#=1, D0-D7=output
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			iBuffer,  // ָһ,׼д
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ


BOOL	WINAPI	USBIO_EppWriteAddr(  // EPPʽдַ: WR#=0, DS#=1, AS#=0, D0-D7=output
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			iBuffer,  // ָһ,׼дĵַ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ


BOOL	WINAPI	USBIO_EppSetAddr(  // EPPʽõַ: WR#=0, DS#=1, AS#=0, D0-D7=output
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	UCHAR			iAddr );  // ָEPPַ


BOOL	WINAPI	USBIO_MemReadAddr0(  // MEMʽַ0: WR#=1, DS#/RD#=0, AS#/ADDR=0, D0-D7=input
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱӵַ0ȡ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_MemReadAddr1(  // MEMʽַ1: WR#=1, DS#/RD#=0, AS#/ADDR=1, D0-D7=input
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱӵַ1ȡ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_MemWriteAddr0(  // MEMʽдַ0: WR#=0, DS#/RD#=1, AS#/ADDR=0, D0-D7=output
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			iBuffer,  // ָһ,׼ַ0д
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ


BOOL	WINAPI	USBIO_MemWriteAddr1(  // MEMʽдַ1: WR#=0, DS#/RD#=1, AS#/ADDR=1, D0-D7=output
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			iBuffer,  // ָһ,׼ַ1д
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ


BOOL	WINAPI	USBIO_SetExclusive(  // öռʹõǰmUSBIO_PACKET_LENGTH豸
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iExclusive );  // Ϊ0豸Թʹ,0ռʹ


BOOL	WINAPI	USBIO_SetTimeout(  // USBݶдĳʱ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iWriteTimeout,  // ָUSBдݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
	ULONG			iReadTimeout );  // ָUSBȡݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)


BOOL	WINAPI	USBIO_ReadData(  // ȡݿ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			oBuffer,  // ָһ㹻Ļ,ڱȡ
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ


BOOL	WINAPI	USBIO_WriteData(  // дݿ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PVOID			iBuffer,  // ָһ,׼д
	PULONG			ioLength );  // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ


PVOID	WINAPI	USBIO_GetDeviceName(  // ָmUSBIO_PACKET_LENGTH豸ƵĻ,򷵻NULL
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸,0Ӧһ豸


ULONG	WINAPI	USBIO_GetVerIC(  // ȡmUSBIO_PACKET_LENGTHоƬİ汾,:0=豸Ч,0x10=mUSBIO_PACKET_LENGTH,0x20=mUSBIO_PACKET_LENGTHA
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


BOOL	WINAPI	USBIO_FlushBuffer(  // mUSBIO_PACKET_LENGTHĻ
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


BOOL	WINAPI	USBIO_WriteRead(  // ִ,
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iWriteLength,  // д,׼дĳ
	PVOID			iWriteBuffer,  // ָһ,׼д
	ULONG			iReadStep,  // ׼ȡĵĳ, ׼ȡܳΪ(iReadStep*iReadTimes)
	ULONG			iReadTimes,  // ׼ȡĴ
	PULONG			oReadLength,  // ָ򳤶ȵԪ,غΪʵʶȡĳ
	PVOID			oReadBuffer );  // ָһ㹻Ļ,ڱȡ


BOOL	WINAPI	USBIO_SetStream(  // ôģʽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iMode );  // ָģʽ,
// λ1-λ0: I2Cӿٶ/SCLƵ, 00=/20KHz,01=׼/100KHz(Ĭֵ),10=/400KHz,11=/750KHz
// λ2:     SPII/O/IO, 0=뵥(D3ʱ/D5/D7)(Ĭֵ),1=˫˫(D3ʱ/D5D4/D7D6)
// λ7:     SPIֽеλ˳, 0=λǰ, 1=λǰ
// ,Ϊ0


BOOL	WINAPI	USBIO_SetDelaymS(  // Ӳ첽ʱ,úܿ췵,һ֮ǰʱָ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iDelay );  // ָʱĺ


BOOL	WINAPI	USBIO_StreamI2C(  // I2C,2߽ӿ,ʱΪSCL,ΪSDA(׼˫I/O),ٶԼ56Kֽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iWriteLength,  // ׼дֽ
	PVOID			iWriteBuffer,  // ָһ,׼д,ֽͨI2C豸ַдλ
	ULONG			iReadLength,  // ׼ȡֽ
	PVOID			oReadBuffer );  // ָһ,غǶ


typedef	enum	_EEPROM_TYPE {					// EEPROMͺ
	ID_24C01,
	ID_24C02,
	ID_24C04,
	ID_24C08,
	ID_24C16,
	ID_24C32,
	ID_24C64,
	ID_24C128,
	ID_24C256,
	ID_24C512,
	ID_24C1024,
	ID_24C2048,
	ID_24C4096
} EEPROM_TYPE;


BOOL	WINAPI	USBIO_ReadEEPROM(  // EEPROMжȡݿ,ٶԼ56Kֽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	EEPROM_TYPE		iEepromID,  // ָEEPROMͺ
	ULONG			iAddr,  // ָݵԪĵַ
	ULONG			iLength,  // ׼ȡֽ
	PUCHAR			oBuffer );  // ָһ,غǶ


BOOL	WINAPI	USBIO_WriteEEPROM(  // EEPROMдݿ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	EEPROM_TYPE		iEepromID,  // ָEEPROMͺ
	ULONG			iAddr,  // ָݵԪĵַ
	ULONG			iLength,  // ׼дֽ
	PUCHAR			iBuffer );  // ָһ,׼д


BOOL	WINAPI	USBIO_GetInput(  // ͨmUSBIO_PACKET_LENGTHֱݺ״̬,ЧʱmUSBIO_PACKET_LENGTHGetStatus
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	PULONG			iStatus );  // ָһ˫ֵԪ,ڱ״̬,ολ˵
// λ7-λ0ӦmUSBIO_PACKET_LENGTHD7-D0
// λ8ӦmUSBIO_PACKET_LENGTHERR#, λ9ӦmUSBIO_PACKET_LENGTHPEMP, λ10ӦmUSBIO_PACKET_LENGTHINT#, λ11ӦmUSBIO_PACKET_LENGTHSLCT, λ23ӦmUSBIO_PACKET_LENGTHSDA
// λ13ӦmUSBIO_PACKET_LENGTHBUSY/WAIT#, λ14ӦmUSBIO_PACKET_LENGTHAUTOFD#/DATAS#,λ15ӦmUSBIO_PACKET_LENGTHSLCTIN#/ADDRS#


BOOL	WINAPI	USBIO_SetOutput(  // mUSBIO_PACKET_LENGTHI/O,ͨmUSBIO_PACKET_LENGTHֱ
/* ***** ʹøAPI, ֹ޸I/OʹűΪŵ֮·оƬ ***** */
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iEnable,  // Ч־,ολ˵
// λ0Ϊ1˵iSetDataOutλ15-λ8Ч,
// λ1Ϊ1˵iSetDirOutλ15-λ8Ч,
// λ2Ϊ1˵iSetDataOut7-λ0Ч,
// λ3Ϊ1˵iSetDirOutλ7-λ0Ч,
// λ4Ϊ1˵iSetDataOutλ23-λ16Ч,
	ULONG			iSetDirOut,  // I/O,ĳλ0ӦΪ,ĳλ1ӦΪ,ڷʽĬֵΪ0x000FC000,ολ˵
	ULONG			iSetDataOut );  // ,I/OΪ,ôĳλ0ʱӦ͵ƽ,ĳλ1ʱӦߵƽ,ολ˵
// λ7-λ0ӦmUSBIO_PACKET_LENGTHD7-D0
// λ8ӦmUSBIO_PACKET_LENGTHERR#, λ9ӦmUSBIO_PACKET_LENGTHPEMP, λ10ӦmUSBIO_PACKET_LENGTHINT#, λ11ӦmUSBIO_PACKET_LENGTHSLCT
// λ13ӦmUSBIO_PACKET_LENGTHWAIT#, λ14ӦmUSBIO_PACKET_LENGTHDATAS#/READ#,λ15ӦmUSBIO_PACKET_LENGTHADDRS#/ADDR/ALE
// ֻ,I/O: λ16ӦmUSBIO_PACKET_LENGTHRESET#, λ17ӦmUSBIO_PACKET_LENGTHWRITE#, λ18ӦmUSBIO_PACKET_LENGTHSCL, λ29ӦmUSBIO_PACKET_LENGTHSDA


BOOL	WINAPI	USBIO_Set_D5_D0(  // mUSBIO_PACKET_LENGTHD5-D0ŵI/O,ͨmUSBIO_PACKET_LENGTHD5-D0ֱ,ЧʱmUSBIO_PACKET_LENGTHSetOutput
/* ***** ʹøAPI, ֹ޸I/OʹűΪŵ֮·оƬ ***** */
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iSetDirOut,  // D5-D0ŵI/O,ĳλ0ӦΪ,ĳλ1ӦΪ,ڷʽĬֵΪ0x00ȫ
	ULONG			iSetDataOut );  // D5-D0ŵ,I/OΪ,ôĳλ0ʱӦ͵ƽ,ĳλ1ʱӦߵƽ
// ݵλ5-λ0ֱӦmUSBIO_PACKET_LENGTHD5-D0


BOOL	WINAPI	USBIO_StreamSPI3(  // SPI,3߽ӿ,ʱΪDCK2/SCL,ΪDIO/SDA(׼˫I/O),ƬѡΪD0/D1/D2,ٶԼ51Kֽ
/* SPIʱ: DCK2/SCLΪʱ, ĬΪ͵ƽ, DIO/SDAʱ֮ǰ, DIO/SDAʱ½֮ */
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iChipSelect,  // Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
	ULONG			iLength,  // ׼ֽ
	PVOID			ioBuffer );  // ָһ,׼DIOд,غǴDIO


BOOL	WINAPI	USBIO_StreamSPI4(  // SPI,4߽ӿ,ʱΪDCK/D3,ΪDOUT/D5,ΪDIN/D7,ƬѡΪD0/D1/D2,ٶԼ68Kֽ
/* SPIʱ: DCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5ʱ֮ǰ, DIN/D7ʱ½֮ */
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iChipSelect,  // Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
	ULONG			iLength,  // ׼ֽ
	PVOID			ioBuffer );  // ָһ,׼DOUTд,غǴDIN


BOOL	WINAPI	USBIO_StreamSPI5(  // SPI,5߽ӿ,ʱΪDCK/D3,ΪDOUT/D5DOUT2/D4,ΪDIN/D7DIN2/D6,ƬѡΪD0/D1/D2,ٶԼ30Kֽ*2
/* SPIʱ: DCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5DOUT2/D4ʱ֮ǰ, DIN/D7DIN2/D6ʱ½֮ */
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iChipSelect,  // Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
	ULONG			iLength,  // ׼ֽ
	PVOID			ioBuffer,  // ָһ,׼DOUTд,غǴDIN
	PVOID			ioBuffer2 );  // ָڶ,׼DOUT2д,غǴDIN2


BOOL	WINAPI	USBIO_BitStreamSPI(  // SPIλ,4/5߽ӿ,ʱΪDCK/D3,ΪDOUT/DOUT2,ΪDIN/DIN2,ƬѡΪD0/D1/D2,ٶԼ8Kλ*2
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸
	ULONG			iLength,  // ׼λ,һ896,鲻256
	PVOID			ioBuffer );  // ָһ,׼DOUT/DOUT2/D2-D0д,غǴDIN/DIN2
/* SPIʱ: DCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5DOUT2/D4ʱ֮ǰ, DIN/D7DIN2/D6ʱ½֮ */
/* ioBufferеһֽڹ8λֱӦD7-D0, λ5DOUT, λ4DOUT2, λ2-λ0D2-D0, λ7DIN, λ6DIN2, λ3ݺ */
/* ڵøAPI֮ǰ,ӦȵmUSBIO_PACKET_LENGTHSet_D5_D0mUSBIO_PACKET_LENGTHD5-D0ŵI/O,ŵĬϵƽ */


BOOL	WINAPI	USBIO_SetBufUpload(  // 趨ڲϴģʽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸,0Ӧһ豸
	ULONG			iEnableOrClear );  // Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
// ڲϴģʽ,ômUSBIO_PACKET_LENGTH򴴽߳ԶUSBϴݵڲ,ͬʱе,ӦómUSBIO_PACKET_LENGTHReadDataػе


LONG	WINAPI	USBIO_QueryBufUpload(  // ѯڲϴеݰ,ɹݰ,-1
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸,0Ӧһ豸


BOOL	WINAPI	USBIO_SetBufDownload(  // 趨ڲ´ģʽ
	ULONG			iIndex,  // ָmUSBIO_PACKET_LENGTH豸,0Ӧһ豸
	ULONG			iEnableOrClear );  // Ϊ0ֹڲ´ģʽ,ʹֱ´,0ڲ´ģʽе
// ڲ´ģʽ,ôӦómUSBIO_PACKET_LENGTHWriteData󽫽ǽUSB´ݷŵڲ,mUSBIO_PACKET_LENGTH򴴽߳Զֱ


LONG	WINAPI	USBIO_QueryBufDownload(  // ѯڲ´еʣݰ(δ),ɹݰ,-1
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸,0Ӧһ豸


BOOL	WINAPI	USBIO_ResetInter(  // λжݶ
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


BOOL	WINAPI	USBIO_ResetRead(  // λݿ
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


BOOL	WINAPI	USBIO_ResetWrite(  // λݿд
	ULONG			iIndex );  // ָmUSBIO_PACKET_LENGTH豸


typedef		VOID	( CALLBACK	* mPmUSBIO_PACKET_LENGTH_NOTIFY_ROUTINE ) (  // 豸¼֪ͨص
	ULONG			iEventStatus );  // 豸¼͵ǰ״̬(ж): 0=豸γ¼, 3=豸¼
/*
#define		mUSBIO_PACKET_LENGTH_DEVICE_ARRIVAL		3		// 豸¼,Ѿ
#define		mUSBIO_PACKET_LENGTH_DEVICE_REMOVE_PEND	1		// 豸Ҫγ
#define		mUSBIO_PACKET_LENGTH_DEVICE_REMOVE			0		// 豸γ¼,Ѿγ
*/
#define		USBIO_DEVICE_ARRIVAL		3		// 豸¼,Ѿ
#define		USBIO_DEVICE_REMOVE_PEND	1		// 豸Ҫγ
#define		USBIO_DEVICE_REMOVE			0		// 豸γ¼,Ѿγ


BOOL	WINAPI	USBIO_SetDeviceNotify(  // 趨豸¼֪ͨ
	ULONG					iIndex,  // ָmUSBIO_PACKET_LENGTH豸,0Ӧһ豸
	PCHAR					iDeviceID,  // ѡ,ַָ,ָص豸ID,ַ\0ֹ
	mPmUSBIO_PACKET_LENGTH_NOTIFY_ROUTINE	iNotifyRoutine );  // ָ豸¼ص,ΪNULLȡ¼֪ͨ,ڼ⵽¼ʱøó


BOOL	WINAPI	USBIO_SetupSerial(  // 趨mUSBIO_PACKET_LENGTHĴ,APIֻڹڴڷʽmUSBIO_PACKET_LENGTHоƬ
	ULONG					iIndex,  // ָmUSBIO_PACKET_LENGTH豸,0Ӧһ豸
	ULONG					iParityMode,  // ָmUSBIO_PACKET_LENGTHڵУģʽ: NOPARITY/ODDPARITY/EVENPARITY/MARKPARITY/SPACEPARITY
	ULONG					iBaudRate );  // ָmUSBIO_PACKET_LENGTHڵͨѶֵ,503000000ֵ֮



#ifdef __cplusplus
}
#endif

#endif		// _mUSBIO_PACKET_LENGTH_DLL_H
