Attribute VB_Name = "USBIOXDLL"
Option Explicit
' 2004.05.28, 2004.10.20, 2005.01.08, 2005.03.25, 2005.04.28
'****************************************
'**  Copyright  (C)  W.ch  1999-2005   **
'**  Web:  http://www.USB-I2C-SPI.com  **
'****************************************
'**  DLL for USB interface chip USB2ISP**
'**  C, VC6.0                          **
'****************************************
'
Public Enum EEPROM_TYPE   ' EEPROMͺŶ
  ID_24C01 = 0
  ID_24C02 = 1
  ID_24C04 = 2
  ID_24C08 = 3
  ID_24C16 = 4
  ID_24C32 = 5
  ID_24C64 = 6
  ID_24C128 = 7
  ID_24C256 = 8
  ID_24C512 = 9
  ID_24C1024 = 10
  ID_24C2048 = 11
  ID_24C4096 = 12
End Enum

Type mUspValue
        mUspValueLow As Byte                  ' 02H ֵֽ
        mUspValueHigh As Byte                 ' 03H ֵֽ
End Type
Type mUspIndex
        mUspIndexLow As Byte                  ' 04H ֽ
        mUspIndexHigh  As Byte                ' 05H ֽ
End Type
Type USB_SETUP_PKT                            ' USBƴĽ׶εṹ
    mUspReqType As Byte                       ' 00H 
    mUspRequest As Byte                       ' 01H 
    mUspValue As mUspValue                    ' 02H-03H ֵ
    mUspIndex As mUspIndex                    ' 04H-05H 
    mLength As Integer                        ' 06H-07H ݽ׶εݳ
End Type

Public Const INVALID_HANDLE_VALUE = -1        '
Public Const mUSBIO_PACKET_LENGTH = 32           ' USB2ISPֵ֧ݰĳ
Public Const mUSBIO_PKT_LEN_SHORT = 8               ' USB2ISPֵ֧Ķݰĳ

Type WIN32_COMMAND                              'WIN32ӿڽṹ
   mFunction As Long                            'ʱָܴ߹ܵ
                                                'ʱز״̬
   mLength As Long                              'ȡ,غݵĳ
   mBuffer(mUSBIO_PACKET_LENGTH - 1) As Byte    'ݻ,Ϊ0255B
End Type
Public mWIN32_COMMAND As WIN32_COMMAND

Public Const FILE_DEVICE_UNKNOWN = &H22
Public Const FILE_ANY_ACCESS = 0
Public Const METHOD_BUFFERED = 0
' WIN32Ӧòӿ
Public Const IOCTL_USBIO_COMMAND = (FILE_DEVICE_UNKNOWN * (2 ^ 16) + FILE_ANY_ACCESS * 2 ^ 14 + &HF34 * 2 ^ 2 + METHOD_BUFFERED)     ' רýӿ

Const mWIN32_COMMAND_HEAD = 8         ' WIN32ӿڵͷ

Public Const mUSBIO_MAX_NUMBER = 16              ' ͬʱӵUSB2ISP

Public Const mMAX_BUFFER_LENGTH = &H1000              ' ݻ󳤶4096

Public Const mMAX_COMMAND_LENGTH = (mWIN32_COMMAND_HEAD + mMAX_BUFFER_LENGTH)             ' ݳȼṹͷĳ

Public Const mDEFAULT_BUFFER_LEN = &H400              ' ݻĬϳ1024

Public Const mDEFAULT_COMMAND_LEN = (mWIN32_COMMAND_HEAD + mDEFAULT_BUFFER_LEN)       ' Ĭݳȼṹͷĳ


' USB2ISP˵ַ
Public Const mUSBIO_ENDP_INTER_UP = &H81              ' USB2ISPжϴ˵ĵַ
Public Const mUSBIO_ENDP_INTER_DOWN = &H1             ' USB2ISPж´˵ĵַ
Public Const mUSBIO_ENDP_DATA_UP = &H82              ' USB2ISPݿϴ˵ĵַ
Public Const mUSBIO_ENDP_DATA_DOWN = &H2            ' USB2ISPݿ´˵ĵַ

' 豸ӿṩĹܵ
Public Const mPipeDeviceCtrl = &H4                  ' USB2ISPۺϿƹܵ
Public Const mPipeInterUp = &H5                       ' USB2ISPжϴܵ
Public Const mPipeDataUp = &H6                         ' USB2ISPݿϴܵ
Public Const mPipeDataDown = &H7                     ' USB2ISPݿ´ܵ

' ӦòӿڵĹܴ
Public Const mFuncNoOperation = &H0                  ' ޲
Public Const mFuncGetVersion = &H1                    ' ȡ汾
Public Const mFuncGetConfig = &H2                   ' ȡUSB豸
Public Const mFuncSetTimeout = &H9                    ' USBͨѶʱ
Public Const mFuncSetExclusive = &HB                  ' öռʹ
Public Const mFuncResetDevice = &HC                  ' λUSB豸
Public Const mFuncResetPipe = &HD                     ' λUSBܵ
Public Const mFuncAbortPipe = &HE                      ' ȡUSBܵ

' USB2ISPרõĹܴ
Public Const mFuncSetParaMode = &HF                   ' òģʽ
Public Const mFuncReadData0 = &H10                   ' Ӳڶȡݿ0
Public Const mFuncReadData1 = &H11                   ' Ӳڶȡݿ1
Public Const mFuncWriteData0 = &H12                  ' 򲢿дݿ0
Public Const mFuncWriteData1 = &H13                  ' 򲢿дݿ1
Public Const mFuncWriteRead = &H14                    ' 


' USB豸׼
Public Const mUSB_CLR_FEATURE = &H1
Public Const mUSB_SET_FEATURE = &H3
Public Const mUSB_GET_STATUS = &H0
Public Const mUSB_SET_ADDRESS = &H5
Public Const mUSB_GET_DESCR = &H6
Public Const mUSB_SET_DESCR = &H7
Public Const mUSB_GET_CONFIG = &H8
Public Const mUSB_SET_CONFIG = &H9
Public Const mUSB_GET_INTERF = &HA
Public Const mUSB_SET_INTERF = &HB
Public Const mUSB_SYNC_FRAME = &HC

' USB2ISPƴĳר
Public Const mUSBIO_VENDOR_READ = &HC0                ' ͨƴʵֵUSB2ISPרö
Public Const mUSBIO_VENDOR_WRITE = &H40             ' ͨƴʵֵUSB2ISPרд

' USB2ISPƴĳר
Public Const mUSBIO_PARA_INIT = &HB1                 ' ʼ
Public Const mUSBIO_I2C_STATUS = &H52                ' ȡI2Cӿڵ״̬
Public Const mUSBIO_I2C_COMMAND = &H53               ' I2Cӿڵ


Public Const mUSBIOA_CMD_I2C_STM_STA = &H74          ' I2Cӿڵ:ʼλ
Public Const mUSBIOA_CMD_I2C_STM_STO = &H75           ' I2Cӿڵ:ֹͣλ
Public Const mUSBIOA_CMD_I2C_STM_OUT = &H0           'I2Cӿڵ:,λ5-λ0Ϊ,ֽΪ,0ֻһֽڲӦ
Public Const mUSBIOA_CMD_I2C_STM_IN = &HC0           ' I2Cӿڵ:,λ5-λ0Ϊ,0ֻһֽڲӦ
Public Const mUSBIOA_CMD_I2C_STM_SET = &H60           ' I2Cӿڵ:ò,λ2=SPII/O(0=뵥,1=˫˫),λ1λ0=I2Cٶ(00=,01=׼,10=,11=)
Public Const mUSBIOA_CMD_I2C_STM_US = &H40           ' I2Cӿڵ:΢Ϊλʱ,λ3-λ0Ϊʱֵ
Public Const mUSBIOA_CMD_I2C_STM_MS = &H50           ' I2Cӿڵ:Ϊλʱ,λ3-λ0Ϊʱֵ
Public Const mUSBIOA_CMD_I2C_STM_DLY = &HF           ' I2Cӿڵʱֵ
Public Const mUSBIOA_CMD_I2C_STM_END = &H0            ' I2Cӿڵ:ǰ


' ֱ״̬źŵλ
Public Const mStateBitERR = &H100                     ' ֻ,ERR#״̬,1:ߵƽ,0:͵ƽ
Public Const mStateBitPEMP = &H200                   ' ֻ,PEMP״̬,1:ߵƽ,0:͵ƽ
Public Const mStateBitINT = &H400                     ' ֻ,INT#״̬,1:ߵƽ,0:͵ƽ
Public Const mStateBitSLCT = &H800                  ' ֻ,SLCT״̬,1:ߵƽ,0:͵ƽ
Public Const mStateBitSDA = &H800000              ' ֻ,SDA״̬,1:ߵƽ,0:͵ƽ




Declare Function USBIO_OpenDevice Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long
' USB2ISP豸,ؾ,Ч
' iIndex  ָUSB2ISP豸,0Ӧһ豸

Declare Sub USBIO_CloseDevice Lib "USBIOX.DLL" (ByVal iIndex As Long)
' رUSB2ISP豸
' iIndex    ָUSB2ISP豸

Declare Function USBIO_GetVersion Lib "USBIOX.DLL" () As Long

' DLL汾,ذ汾

Declare Function USBIO_DriverCommand Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef ioCommand As WIN32_COMMAND) As Long
' ֱӴ,򷵻0,򷵻ݳ
' iIndex,  ' ָUSB2ISP豸,V1.6DLLҲ豸򿪺ľ
' ioCommand   ṹĵַ
' óڵú󷵻ݳ,Ȼṹ,Ƕ,ݷṹ,
' صݳڲʧʱΪ0,ɹʱΪṹĳ,һֽ,򷵻mWIN32_COMMAND_HEAD+1,
' ṹڵǰ,ֱṩ:ܵŻܴ,ȡݵĳ(ѡ),(ѡ)
' ṹڵú,ֱ𷵻:״̬,ݵĳ(ѡ),
'   ״̬WINDOWSĴ,ԲοNTSTATUS.H,
'   ݵĳָصݳ,ݴĻ,дһΪ0

Declare Function USBIO_GetDrvVersion Lib "USBIOX.DLL" () As Long

' 汾,ذ汾,򷵻0

Declare Function USBIO_ResetDevice Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean

'λUSB豸
' iIndex  ָUSB2ISP豸

Declare Function USBIO_GetDeviceDescr Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡ豸
' iIndex,   ָUSB2ISP豸
' oBuffer   ָһ㹻Ļ,ڱ
' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_GetConfigDescr Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡ
'  iIndex,    ָUSB2ISP豸
'  oBuffer,   ָһ㹻Ļ,ڱ
'  ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_SetIntRoutine Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iIntRoutine As Long) As Boolean
'趨жϷ
' ָUSB2ISP豸
'ָжϷ,ΪNULLȡжϷ,жʱøó


Declare Function USBIO_ReadInter Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iStatus As Long) As Boolean
' ȡж
' iIndex,  ָUSB2ISP豸
' iStatus   ָһ˫ֵԪ,ڱȡж״̬,
' λ7-λ0ӦUSB2ISPD7-D0
'  λ8ӦUSB2ISPERR#, λ9ӦUSB2ISPPEMP, λ10ӦUSB2ISPINT#, λ11ӦUSB2ISPSLCT

Declare Function USBIO_AbortInter Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' жݶ
' iIndex   ָUSB2ISP豸

Declare Function USBIO_ReadData0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' 0#˿ڶȡݿ
 ' iIndex     ָUSB2ISP豸
 ' oBuffer   ָһ㹻Ļ,ڱȡ
 ' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_ReadData1 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' 1#˿ڶȡݿ
' iIndex,  ָUSB2ISP豸
' oBuffer ָһ㹻Ļ,ڱȡ
' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_AbortRead Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' ݿ
' iIndex    ָUSB2ISP豸

Declare Function USBIO_WriteData0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
' 0#˿дݿ
' iIndex,    ָUSB2ISP豸
' iBuffer     ָһ,׼д
' ioLength  ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_WriteData1 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
' 1#˿дݿ
' iIndex,    ָUSB2ISP豸
' iBuffer,    ָһ,׼д
' ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_AbortWrite Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' ݿд
' iIndex   ָUSB2ISP豸

Declare Function USBIO_GetStatus Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iStatus As Long) As Boolean
'  ͨUSB2ISPֱݺ״̬
'  iIndex,   ָUSB2ISP豸
'  iStatus  ָһ˫ֵԪ,ڱ״̬,
'  λ7-λ0ӦUSB2ISPD7-D0
'  λ8ӦUSB2ISPERR#, λ9ӦUSB2ISPPEMP, λ10ӦUSB2ISPINT#, λ11ӦUSB2ISPSLCT, λ23ӦUSB2ISPSDA
'  λ13ӦUSB2ISPBUSY/WAIT#, λ14ӦUSB2ISPAUTOFD#/DATAS#,λ15ӦUSB2ISPSLCTIN#/ADDRS#

Declare Function USBIO_ReadI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDevice As Byte, ByVal iAddr As Byte, ByRef oByte As Byte) As Boolean

'  I2Cӿڶȡһֽ
'  iIndex,   ָUSB2ISP豸
'  iDevice,    7λָI2C豸ַ
'  iAddr,    ָݵԪĵַ
'  oByte    ָһֽڵԪ,ڱȡֽ

Declare Function USBIO_WriteI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDevice As Byte, ByVal iAddr As Byte, ByVal iByte As Byte) As Boolean

'    I2Cӿдһֽ
'    iIndex,   ָUSB2ISP豸
'    iDevice,   7λָI2C豸ַ
'    iAddr,  ָݵԪĵַ
'    iByte  дֽ

Declare Function USBIO_EppReadData Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
'  EPPʽ: WR#=1, DS#=0, AS#=1, D0-D7=input
'  iIndex,    ָUSB2ISP豸
'  oBuffer,    ָһ㹻Ļ,ڱȡ
'  ioLength    ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_EppReadAddr Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
'  EPPʽַ: WR#=1, DS#=1, AS#=0, D0-D7=input
'  iIndex,    ָUSB2ISP豸
'  oBuffer,    ָһ㹻Ļ,ڱȡĵַ
'  ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_EppWriteData Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
'   EPPʽд: WR#=0, DS#=0, AS#=1, D0-D7=output
'   iIndex,     ָUSB2ISP豸
'   iBuffer,    ָһ,׼д
'   ioLength     ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_EppWriteAddr Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
'   EPPʽдַ: WR#=0, DS#=1, AS#=0, D0-D7=output
'   iIndex,    ָUSB2ISP豸
'   iBuffer,    ָһ,׼дĵַ
'   ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_MemReadAddr0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' MEMʽַ0: WR#=1, DS#/RD#=0, AS#/ADDR=0, D0-D7=input
' iIndex,    ָUSB2ISP豸
' oBuffer,     ָһ㹻Ļ,ڱӵַ0ȡ
' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_MemReadAddr1 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' MEMʽַ1: WR#=1, DS#/RD#=0, AS#/ADDR=1, D0-D7=input
' iIndex,    ָUSB2ISP豸
' oBuffer,    ָһ㹻Ļ,ڱӵַ1ȡ
' ioLength    ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_MemWriteAddr0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
' MEMʽдַ0: WR#=0, DS#/RD#=1, AS#/ADDR=0, D0-D7=output
' iIndex,    ָUSB2ISP豸
' iBuffer,    ָһ,׼ַ0д
' ioLength    ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_MemWriteAddr1 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
'  MEMʽдַ1: WR#=0, DS#/RD#=1, AS#/ADDR=1, D0-D7=output
'  iIndex,   ָUSB2ISP豸
'  iBuffer,    ָһ,׼ַ1д
'  ioLength      ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_SetExclusive Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iExclusive As Long) As Boolean
' öռʹõǰUSB2ISP豸
' iIndex,    ָUSB2ISP豸
' iExclusive  Ϊ0豸Թʹ,0ռʹ

Declare Function USBIO_SetTimeout Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteTimeout As Long, ByVal iReadTimeout As Long) As Boolean
'  USBݶдĳʱ
'  iIndex,  // ָUSB2ISP豸
'  iWriteTimeout  ָUSBдݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
'  iReadTimeout  ָUSBȡݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)

Declare Function USBIO_ReadData Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡݿ
' iIndex,    ָUSB2ISP豸
' oBuffer,    ָһ㹻Ļ,ڱȡ
' ioLength      ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_WriteData Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
'  дݿ
'  iIndex,    ָUSB2ISP豸
'  iBuffer,    ָһ,׼д
'  ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_GetDeviceName Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long           ''''
' ָUSB2ISP豸ƵĻ,򷵻NULL
' iIndex   ָUSB2ISP豸,0Ӧһ豸

Declare Function USBIO_FlushBuffer Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' USB2ISPĻ
' iIndex   ָUSB2ISP豸

Declare Function USBIO_WriteRead Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteLength As Long, ByRef iWriteBuffer As Any, ByVal iReadStep As Long, ByVal iReadTimes As Long, ByRef oReadLength As Long, ByRef oReadBuffer As Any) As Boolean
' USBIO_WriteRead   ִ,
' iIndex,    ָUSB2ISP豸
' iWriteLength,   д,׼дĳ
' iWriteBuffer,    ָһ,׼д
' iReadStep,    ׼ȡĵĳ, ׼ȡܳΪ(iReadStep*iReadTimes)
' iReadTimes,    ׼ȡĴ
' oReadLength,    ָ򳤶ȵԪ,غΪʵʶȡĳ
' oReadBuffer      ָһ㹻Ļ,ڱȡ

Declare Function USBIO_SetStream Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iMode As Long) As Boolean
' USBIO_SetStream   ôģʽ
' iIndex,    ָUSB2ISP豸
' iMode      ָģʽ,
' λ1-λ0: I2Cӿٶ/SCLƵ, 00=/20KHz,01=׼/100KHz,10=/400KHz,11=/750KHz
' λ2:     SPII/O/IO, 0=뵥(D5/D7),1=˫˫(D5D4/D7D6)
' λ7:     SPIֽеλ˳, 0=λǰ, 1=λǰ
' ,Ϊ0

Declare Function USBIO_SetDelaymS Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDelay As Long) As Boolean
'  USBIO_SetDelaymS     Ӳ첽ʱ,úܿ췵,һ֮ǰʱָ
 ' iIndex,    ָUSB2ISP豸
 ' iDelay      ָʱĺ

Declare Function USBIO_StreamI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteLength As Long, ByRef iWriteBuffer As Any, ByVal iReadLength As Long, ByRef oReadBuffer As Any) As Boolean
' USBIO_StreamI2C     I2C,2߽ӿ,ʱΪSCL,ΪSDA(׼˫I/O),ٶԼ56Kֽ
' iIndex,    ָUSB2ISP豸
' iWriteLength,    ׼дֽ
' iWriteBuffer,    ָһ,׼д,ֽͨI2C豸ַдλ
' iReadLength,     ׼ȡֽ
' oReadBuffer     ָһ,غǶ
Declare Function USBIO_ReadEEPROM Lib "USBIOX.DLL" (ByVal iIndexas As Long, ByVal iEepromID As EEPROM_TYPE, ByVal iAddr As Long, ByVal iLength As Long, ByRef oBuffer As Any) As Boolean
' i    Index  ָUSB2ISP豸
' iEepromID   ָEEPROMͺ
' iAddr       ָݵԪĵַ
' iLength     ׼ȡֽ
' oBuffer     ָһ,غǶ

Declare Function USBIO_WriteEEPROM Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEepromID As EEPROM_TYPE, ByVal iAddr As Long, ByVal iLength As Long, ByRef iBuffer As Any) As Boolean
' iIndex,    ָUSB2ISP豸
' iEepromID, ָEEPROMͺ
' iAddr,     ָݵԪĵַ
' iLength,   ׼дֽ
' iBuffer    ָһ,׼д
'----------------------------------------------------------------------------------------
Declare Function USBIO_GetInput Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iStatus As Long) As Boolean
' USBIO_GetInput ͨUSB2ISPֱݺ״̬,ЧʱUSBIO_GetStatus
' iIndex,  ָUSB2ISP豸
' iStatus  ָһ˫ֵԪ,ڱ״̬,ολ˵
' λ7-λ0ӦUSB2ISPD7-D0
' λ8ӦUSB2ISPERR#, λ9ӦUSB2ISPPEMP, λ10ӦUSB2ISPINT#, λ11ӦUSB2ISPSLCT, λ23ӦUSB2ISPSDA
' λ13ӦUSB2ISPBUSY/WAIT#, λ14ӦUSB2ISPAUTOFD#/DATAS#,λ15ӦUSB2ISPSLCTIN#/ADDRS#

Declare Function USBIO_SetOutput Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEnable As Long, ByVal iSetDirOut As Long, ByVal iSetDataOut As Long) As Boolean
' USBIO_SetOutput USB2ISPI/O,ͨUSBIO_ֱ
' ***** ʹøAPI, ֹ޸I/OʹűΪŵ֮·оƬ *****
' iIndex,  ָUSB2ISP豸
' iEnable, Ч־,ολ˵
'// λ0Ϊ1˵iSetDataOutλ15-λ8Ч,
'// λ1Ϊ1˵iSetDirOutλ15-λ8Ч,
'// λ2Ϊ1˵iSetDataOut7-λ0Ч,
'// λ3Ϊ1˵iSetDirOutλ7-λ0Ч,
'// λ4Ϊ1˵iSetDataOutλ23-λ16Ч,
' iSetDirOut, I/O,ĳλ0ӦΪ,ĳλ1ӦΪ,ڷʽĬֵΪ0x000FC000,ολ˵
' iSetDataOut ,I/OΪ,ôĳλ0ʱӦ͵ƽ,ĳλ1ʱӦߵƽ,ολ˵
'// λ7-λ0ӦUSB2ISPD7-D0
'// λ8ӦUSB2ISPERR#, λ9ӦUSB2ISPPEMP, λ10ӦUSB2ISPINT#, λ11ӦUSB2ISPSLCT
'// λ13ӦUSB2ISPWAIT#, λ14ӦUSB2ISPDATAS#/READ#,λ15ӦUSB2ISPADDRS#/ADDR/ALE
'// ֻ,I/O: λ16ӦUSB2ISPRESET#, λ17ӦUSB2ISPWRITE#, λ18ӦUSB2ISPSCL, λ29ӦUSB2ISPSDA

Declare Function USBIO_Set_D5_D0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iSetDirOut As Long, ByVal iSetDataOut As Long) As Boolean
' USBIO_Set_D5_D0 USB2ISPD5-D0ŵI/O,ͨUSB2ISPD5-D0ֱ,ЧʱUSBIO_SetOutput
' ***** ʹøAPI, ֹ޸I/OʹűΪŵ֮·оƬ *****
' iIndex,      ָUSB2ISP豸
' iSetDirOut,  D5-D0ŵI/O,ĳλ0ӦΪ,ĳλ1ӦΪ,ڷʽĬֵΪ0x00ȫ
' iSetDataOut  D5-D0ŵ,I/OΪ,ôĳλ0ʱӦ͵ƽ,ĳλ1ʱӦߵƽ
'// ݵλ5-λ0ֱӦUSB2ISPD5-D0

Declare Function USBIO_StreamSPI3 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iChipSelect As Long, ByVal iLength As Long, ByRef ioBuffer As Any) As Boolean
' USBIO_StreamSPI3 SPI,3߽ӿ,ʱΪSCK/SCL,ΪDIO/SDA(׼˫I/O),ƬѡΪD0/D1/D2,ٶԼ51Kֽ
' SPIʱ: SCK2/SCLΪʱ, ĬΪ͵ƽ, DIO/SDAʱ֮ǰ, DIO/SDAʱ½֮
' iIndex,   ָUSB2ISP豸
' iChipSelect,Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
' iLength,    ׼ֽ
' ioBuffer    ָһ,׼DIOд,غǴDIO

Declare Function USBIO_StreamSPI4 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iChipSelect As Long, ByVal iLength As Long, ByRef ioBuffer As Any) As Boolean
' USBIO_StreamSPI4 SPI,4߽ӿ,ʱΪSCK/D3,ΪDOUT/D5/MOSI,ΪDIN/D7/MISO,ƬѡΪD0/D1/D2,ٶԼ68Kֽ
' SPIʱ: SCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5/MOSIʱ֮ǰ, DIN/D7/MISOʱ½֮
' iIndex,   ָUSB2ISP豸
' iChipSelect,Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
' iLength,    ׼ֽ
' ioBuffer    ָһ,׼DOUT/MOSIд,غǴDIN/MISO

Declare Function USBIO_StreamSPI5 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iChipSelect As Long, ByVal iLength As Long, ByRef ioBuffer As Any, ByRef ioBuffer2 As Any) As Boolean
' USBIO_StreamSPI5 SPI,5߽ӿ,ʱΪSCK/D3,ΪDOUT/D5/MOSIDOUT2/D4,ΪDIN/D7/MISODIN2/D6,ƬѡΪD0/D1/D2,ٶԼ30Kֽ*2
' SPIʱ: SCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5/MOSIDOUT2/D4ʱ֮ǰ, DIN/D7/MISODIN2/D6ʱ½֮
' iIndex,   ָUSB2ISP豸
' iChipSelect,Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
' iLength,    ׼ֽ
' ioBuffer,   ָһ,׼DOUT/MOSIд,غǴDIN/MISO
' ioBuffer2   ָڶ,׼DOUT/MOSI2д,غǴDIN/MISO2

Declare Function USBIO_BitStreamSPI Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iLength As Long, ByRef ioBuffer As Any) As Boolean
' USBIO_BitStreamSPI SPIλ,4/5߽ӿ,ʱΪSCK/D3,ΪDOUT/DOUT2,ΪDIN/DIN2,ƬѡΪD0/D1/D2,ٶԼ8Kλ*2
' iIndex,  ָUSB2ISP豸
' iLength, ׼λ,һ896,鲻256
' ioBuffer ָһ,׼DOUT/MOSI/DOUT2/D2-D0д,غǴDIN/MISO/DIN2
'/* SPIʱ: SCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5/MOSIDOUT2/D4ʱ֮ǰ, DIN/D7/MISODIN2/D6ʱ½֮ */
'/* ioBufferеһֽڹ8λֱӦD7-D0, λ5DOUT, λ4DOUT2, λ2-λ0D2-D0, λ7DIN/MISO, λ6DIN/MISO2, λ3ݺ */
'/* ڵøAPI֮ǰ,ӦȵUSBIO_Set_D5_D0USB2ISPD5-D0ŵI/O,ŵĬϵƽ */

'-------------------------------------------------------------------------

Declare Function USBIO_SetBufUpload Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEnableOrClear As Long) As Boolean  ' Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
' USBIO_SetBufUpload  ' 趨ڲϴģʽ
' iIndex,          0ָUSB2ISP豸,0Ӧһ豸
' iEnableOrClear  Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
' ڲϴģʽ,ôUSB2ISP򴴽߳ԶUSBϴݵڲ,ͬʱе,ӦóUSBIO_ReadDataػе

Declare Function USBIO_QueryBufUpload Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long
' USBIO_QueryBufUpload   ѯڲϴеݰ,ɹݰ,-1
' iIndex                ָUSB2ISP豸,0Ӧһ豸

Declare Function USBIO_SetBufDownload Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEnableOrClear As Long) As Boolean
'  USBIO_SetBufDownload  趨ڲ´ģʽ
'  iIndex,              ָUSB2ISP豸,0Ӧһ豸
'  iEnableOrClear       Ϊ0ֹڲ´ģʽ,ʹֱ´,0ڲ´ģʽе
'  ڲ´ģʽ,ôӦóUSBIO_WriteData󽫽ǽUSB´ݷŵڲ,USB2ISP򴴽߳Զֱ

Declare Function USBIO_QueryBufDownload Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long    ' ָUSB2ISP豸,0Ӧһ豸
'  USBIO_QueryBufDownload  ѯڲ´еʣݰ(δ),ɹݰ,-1
'  iIndex                 ָUSB2ISP豸,0Ӧһ豸


Declare Function USBIO_ResetInter Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'  USBIO_ResetInter   λжݶ
'  iIndex            ָUSB2ISP豸

Declare Function USBIO_ResetRead Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'  USBIO_ResetRead  λݿ
'  iIndex          ָUSB2ISP豸

Declare Function USBIO_ResetWrite Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'    USBIO_ResetRead    λݿ
'    iIndex            ָUSB2ISP豸

'typedef     VOID    ( CALLBACK  * mUSBIO_NOTIFY_ROUTINE ) (  ' 豸¼֪ͨص
'    ULONG           iEventStatus );  ' 豸¼͵ǰ״̬(ж): 0=豸γ¼, 3=豸¼

Public Const USBIO_DEVICE_ARRIVAL = 3               ' 豸¼,Ѿ
Public Const USBIO_DEVICE_REMOVE_PEND = 1         ' 豸Ҫγ
Public Const USBIO_DEVICE_REMOVE = 0              ' 豸γ¼,Ѿγ

Declare Function USBIO_SetDeviceNotify Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iDeviceID As String, ByVal iNotifyRoutine As Long) As Boolean
'  USBIO_SetDeviceNotify     趨豸¼֪ͨ
'  iIndex,                  ָUSB2ISP豸,0Ӧһ豸
'  iDeviceID,               ѡ,ַָ,ָص豸ID,ַ\0ֹ
'  iNotifyRoutine           (ַ)ָ豸¼ص, ΪNULLȡ¼֪ͨ, ڼ⵽¼ʱøó

