//****************************************
//**  Copyright  (C)  USBIO  1999-2004  **
//**  Web:  http://www.usb-i2c-spi.com  **
//****************************************
//**  C, VC6.0                          **
//****************************************
//
// USB2I2C I2Cٶ
//


#include	<windows.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<conio.h>
#include	<winioctl.h>

#include	"USBIOX.H"				// USB2I2CĶ̬ӿ

//
void main ( )
{
	unsigned char	mBuffer[4100];
	unsigned long	i, mLength, mTestCount, mErrCnt, mStep, mTotal;
	double          speed;

	printf( "\nUSB2I2C Bulk Data Test Program V0.2 , Copyright (C) USBIO TECH. 2003.12\n" );

// ҪʹDLLҪȼ
	printf( "Load DLL: USBIOX.DLL ......\n" );
	if ( LoadLibrary( "USBIOX.DLL" ) == NULL ) return;  // DLLʧ,δװϵͳ

	printf( "USBIO_OpenDevice: 0# \n" );
	if ( USBIO_OpenDevice( 0 ) == INVALID_HANDLE_VALUE ) return;  /* ʹ֮ǰ豸 */
	mErrCnt = 0;
	
	printf( "*** Step-1: test speed of download data: 2048KB data \n" );
	for ( i=0; i<4096; i+=4 ) *(unsigned long *)(&mBuffer[i])=rand();  // Է
	mTotal=0;
	mStep=GetTickCount();
	for ( mTestCount=0; mTestCount<500; ++mTestCount )  // ѭ
	{
		*(unsigned long *)(&mBuffer[4])=mTestCount;
		mLength = 4096;
		if ( USBIO_EppWriteData( 0, &mBuffer, &mLength ) )  // ͳɹ
		{
			if ( mLength != 4096 ) printf( "S2-C%ld USBIO_WriteData actual length short %ld (4096)\n", mLength );
			mTotal +=mLength;  // ۼƳ
		}
		else {  // дʧ
			mErrCnt++;
			printf( "S2-C%ld USBIO_WriteData return error\n", mTestCount );
		}
	}
	mLength=GetTickCount();
	mLength=mLength-mStep;
	speed=1000;
	if ( mLength !=0 ) speed=speed*mTotal/mLength;
	else speed=9999999;
	printf( "*** download speed = %7.1f Bytes/Sec, total=%ld bytes, time=%ld mS\n", speed, mTotal, mLength);
	Sleep(100);

	printf( "*** Step-2: test speed of upload data: 2048KB data\n" );
	mTotal=0;
	mStep=GetTickCount();
	for ( mTestCount=0; mTestCount<500; ++mTestCount )  // ѭ
	{
		mLength = 4096;
		if ( USBIO_EppReadData( 0, &mBuffer, &mLength ) )  // ճɹ
		{
			if ( mLength != 4096 ) printf( "S3-C%ld USBIO_ReadData actual length short %ld (4096)\n", mLength );
			mTotal +=mLength;  // ۼƳ
		}
		else {  // ʧ
			mErrCnt++;
			printf( "S3-C%ld USBIO_ReadData return error\n", mTestCount );
		}
	}
	mLength=GetTickCount();
	mLength=mLength-mStep;
	speed=1000;
	if ( mLength !=0 ) speed=speed*mTotal/mLength;
	else speed=9999999;
	printf( "*** upload speed = %7.1f Bytes/Sec, total=%ld bytes, time=%ld mS\n", speed, mTotal, mLength);
	Sleep(100);

// رUSB2I2C豸,ʹر豸,дӲеļҪرһ
	printf( "*** Total error = %ld \n", mErrCnt );
	printf( "*** USBIO_CloseDevice: 0 \n" );
	USBIO_CloseDevice( 0 );

	printf( "\nExit.\n" );
	getch();
}

