// V1.2

#include	<windows.h>
#include	"USBIOX.H"

/* 漰
 12߽ӿTWIһЩԶʱ,I2CߵӦλ,Լ˽2߽ӿڵڲʱ
 2ṩӳ,2߽ӿI2CX76F640PCF8574PCA9554
*/

/* USB2I2CDLLAPI,ӵ߷Ϊ
 1USBIO_WriteDataֻд, USBIO_ReadDataֻ, USBIO_WriteReadдٶ
 2USBIO_StreamI2CдI2C,ѡٶI2C (ڲUSBIO_WriteDataUSBIO_WriteRead)
 3USBIO_ReadEEPROMEEPROM, USBIO_WriteEEPROMдEEPROM (ڲUSBIO_StreamI2C)
 еӳ򽫵USBIO_WriteDataUSBIO_WriteReadUSBIO_StreamI2CDLLеAPI */

/* ʵٶ
   USBIO_StreamI2C     Լ56Kֽ
   USBIO_ReadEEPROM    Լ56Kֽ
   USBIO_WriteEEPROM   Լ5Kֽ(RAMôUSBIO_ReadEEPROMٶͬ)
*/

/* ********************************************************************************************** */
/* I2Cߵͨòʱ */

BOOL	WINAPI	I2C_IssueStart(
	ULONG			iIndex )  // ָUSB2I2C豸
{
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength;
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = mUSBIOSS_CMD_I2C_STM_STA;  // ʼλ
	mBuffer[ 2 ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 3;
	return( USBIO_WriteData( iIndex, mBuffer, &mLength ) );  // дݿ
}

BOOL	WINAPI	I2C_IssueStop(
	ULONG			iIndex )  // ָUSB2I2C豸
{
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength;
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = mUSBIOSS_CMD_I2C_STM_STO;  // ֹͣλ
	mBuffer[ 2 ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 3;
	return( USBIO_WriteData( iIndex, mBuffer, &mLength ) );  // дݿ
}

BOOL	WINAPI	I2C_OutBlockSkipAck(  // ݿ,Ӧ
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iOutLength,  // ׼дֽ,αС29ֽ
	PVOID			iOutBuffer )  // ָһ,׼д
{
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength;
	if ( iOutLength == 0 || iOutLength > ( mUSBIO_PACKET_LENGTH - 1 - 1 - 1 ) ) return( FALSE );
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_OUT | iOutLength );  // ,λ5-λ0Ϊ
	memcpy( &mBuffer[2], iOutBuffer, iOutLength );  // 
	mBuffer[ 1 + 1 + iOutLength ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 1 + 1 + iOutLength + 1;
	return( USBIO_WriteData( iIndex, mBuffer, &mLength ) );  // дݿ
}

BOOL	WINAPI	I2C_OutByteCheckAck(  // һֽݲӦǷЧ
	ULONG			iIndex,  // ָUSB2I2C豸
	UCHAR			iOutByte )  // ׼д
{
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength, mInLen;
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = mUSBIOSS_CMD_I2C_STM_OUT;  // ,λ5-λ0Ϊ,0ֻһֽڲӦ
	mBuffer[ 2 ] = iOutByte;  // 
	mBuffer[ 3 ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 4;
	mInLen = 0;
	if ( USBIO_WriteRead( iIndex, mLength, mBuffer, mUSBIOSS_CMD_I2C_STM_MAX, 1, &mInLen, mBuffer ) ) {  // ִ,
		if ( mInLen && ( mBuffer[ mInLen - 1 ] & 0x80 ) == 0 ) return( TRUE );  // صݵλ7ACKӦλ,ACK=0Ч
	}
	return( FALSE );
}

BOOL	WINAPI	I2C_InBlockByAck(  // ݿ,ÿһֽڶЧӦ
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iInLength,  // ׼ȡֽ,αС32ֽ
	PVOID			oInBuffer )  // ָһ,غǶ
{
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength, mInLen;
	if ( iInLength == 0 || iInLength > mUSBIOSS_CMD_I2C_STM_MAX ) return( FALSE );
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_IN | iInLength );  // ,λ5-λ0Ϊ
	mBuffer[ 2 ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 3;
	mInLen = 0;
	if ( USBIO_WriteRead( iIndex, mLength, mBuffer, mUSBIOSS_CMD_I2C_STM_MAX, 1, &mInLen, mBuffer ) ) {  // ִ,
		if ( mInLen == iInLength ) {
			memcpy( oInBuffer, &mBuffer[0], iInLength );  // 
			return( TRUE );
		}
	}
	return( FALSE );
}

BOOL	WINAPI	I2C_InByteNoAck(  // һֽ,ǲӦ
	ULONG			iIndex,  // ָUSB2I2C豸
	PUCHAR			oInByte )  // ָһֽڵĻ,غǶ
{
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength, mInLen;
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = mUSBIOSS_CMD_I2C_STM_IN;  // ,λ5-λ0Ϊ,0ֻһֽڲӦ
	mBuffer[ 2 ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 3;
	mInLen = 0;
	if ( USBIO_WriteRead( iIndex, mLength, mBuffer, mUSBIOSS_CMD_I2C_STM_MAX, 1, &mInLen, mBuffer ) ) {  // ִ,
		if ( mInLen ) {
			*oInByte = mBuffer[ mInLen - 1 ];  // 
			return( TRUE );
		}
	}
	return( FALSE );
}

/* ********************************************************************************************** */
/* ܴ洢X76F640 */

BOOL	WINAPI	X76F640_AckPolling(  // ѯX76F640Ӧ (:ʼλ,һֽ,ӦǷЧ)
	ULONG			iIndex )  // ָUSB2I2C豸
{
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength, mInLen;
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = mUSBIOSS_CMD_I2C_STM_STA;  // ʼλ
	mBuffer[ 2 ] = mUSBIOSS_CMD_I2C_STM_OUT;  // ,λ5-λ0Ϊ,0ֻһֽڲӦ
	mBuffer[ 3 ] = 0xF0;  // Ӧѯ
	mBuffer[ 4 ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 5;
	mInLen = 0;
	if ( USBIO_WriteRead( iIndex, mLength, mBuffer, mUSBIOSS_CMD_I2C_STM_MAX, 1, &mInLen, mBuffer ) ) {  // ִ,
		if ( mInLen && ( mBuffer[ mInLen - 1 ] & 0x80 ) == 0 ) return( TRUE );  // صݵλ7ACKӦλ,ACK=0Ч
	}
	return( FALSE );
}

BOOL	WINAPI	X76F640_CheckPasswd(  // ָ (:ʼλ,9ֽ(1+8),ѯӦ,2ֽڵַ)
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iCommand,  // 
	PVOID			iPasswdBuf,  // ָһ,ṩ8ֽڵ
	ULONG			iAddress )  // ַָ2ֽ
{
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	i, mLength;
	i = 0;
	mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STM_STA;  // ʼλ
	mBuffer[ i++ ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_OUT | 9 );  // ,λ5-λ0Ϊ,9ֽ
	mBuffer[ i++ ] = (UCHAR)iCommand;  // 
	memcpy( &mBuffer[ i ], iPasswdBuf, 8 );  // 8ֽ
	i += 8;
	mBuffer[ i++ ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_MS | 10 );  // Ϊλʱ,λ3-λ0Ϊʱֵ,ʱ10
	mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = i;
	if ( USBIO_WriteData( iIndex, mBuffer, &mLength ) ) {  // дݿ
		if ( X76F640_AckPolling( iIndex ) ) {  // ѯӦЧ
			i = 0;
			mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STREAM;  // 
			mBuffer[ i++ ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_OUT | 2 );  // ,λ5-λ0Ϊ
			mBuffer[ i++ ] = (UCHAR)( iAddress & 0x00FF );  // ַ8λ
			mBuffer[ i++ ] = (UCHAR)( ( iAddress >> 8 ) & 0x00FF );  // ַ8λ
			mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
			mLength = i;
			return( USBIO_WriteData( iIndex, mBuffer, &mLength ) );  // дݿ
		}
		else I2C_IssueStop( iIndex );  // ӦЧ
	}
	return( FALSE );
}

BOOL	WINAPI	X76F640_WriteWithPasswd(  // дX76F640Ŀ,ʹָ
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iWriteCommand,  // д
	PVOID			iPasswdBuf,  // ָһ,8ֽڵ
	ULONG			iAddress,  // ַָ
	ULONG			iOutLength,  // ׼дֽ,αС32ֽ(1)
	PVOID			iOutBuffer )  // ָһ,׼д
{
	UCHAR	mBuffer[ mDEFAULT_BUFFER_LEN ];
	ULONG	i, mLength;
	if ( iOutLength == 0 || iOutLength > 32 ) return( FALSE );
	if ( X76F640_CheckPasswd( iIndex, iWriteCommand, iPasswdBuf, iAddress ) ) {  // ͨ
		if ( iOutLength > ( mUSBIO_PACKET_LENGTH - 1 - 1 - 1 - 1 - 1 ) ) {  // ȥǰ2ֽں3ֽ,һ
			mLength = iOutLength - ( mUSBIO_PACKET_LENGTH - 1 - 1 - 1 - 1 - 1);  // ĳ
			iOutLength -= mLength;  // 1ݳ
		}
		else mLength = 0;  // 1͹
		i = 0;
		mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STREAM;  // 
		mBuffer[ i++ ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_OUT | iOutLength );  // ,λ5-λ0Ϊ
		memcpy( &mBuffer[ i ], iOutBuffer, iOutLength );  // 
		i += iOutLength;
		if ( mLength ) {  // 2
			mBuffer[ i ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
			i += mUSBIO_PACKET_LENGTH - i % mUSBIO_PACKET_LENGTH;  // ǰʣಿ
			mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STREAM;  // 2ֽȻ
			mBuffer[ i++ ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_OUT | mLength );  // ,λ5-λ0Ϊ
			memcpy( &mBuffer[ i ], (PUCHAR)iOutBuffer + iOutLength, mLength );  // ʣ
			i += mLength;
		}
		mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STM_STO;  // ֹͣλ
		mBuffer[ i++ ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_MS | 10 );  // Ϊλʱ,λ3-λ0Ϊʱֵ,ʱ10
		mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
		return( USBIO_WriteData( iIndex, mBuffer, &i ) );  // дݿ
	}
	return( FALSE );
}

BOOL	WINAPI	X76F640_ReadWithPasswd(  // X76F640Ŀ,ʹָ (:ʼλ,9ֽ(1+8),ѯӦ,2ֽڵַ,ݿ)
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iReadCommand,  // 
	PVOID			iPasswdBuf,  // ָһ,8ֽڵ
	ULONG			iAddress,  // ַָ
	ULONG			iInLength,  // ׼ȡֽ,αС512ֽ ( ÿ32 * 16 = 512ֽ )
	PVOID			oInBuffer )  // ָһ,غǶ
{
	UCHAR	mBuffer[ mDEFAULT_BUFFER_LEN ];
	ULONG	i, mLength, mInLen;
	if ( iInLength == 0 || iInLength > ( 16 * mUSBIO_PACKET_LENGTH ) ) return( FALSE );
	if ( X76F640_CheckPasswd( iIndex, iReadCommand, iPasswdBuf, iAddress ) ) {  // ͨ
		i = 0;
		mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STREAM;  // 
		for ( mInLen = 1; mInLen < iInLength; ) {
			mLength = iInLength - mInLen >= mUSBIOSS_CMD_I2C_STM_MAX ? mUSBIOSS_CMD_I2C_STM_MAX : iInLength - mInLen;  // Чݳ
			mBuffer[ i++ ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_IN | mLength );  // ,λ5-λ0Ϊ
			mInLen += mLength;
			if ( mLength >= mUSBIOSS_CMD_I2C_STM_MAX ) {  // ǰ
				mBuffer[ i ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
				i += mUSBIO_PACKET_LENGTH - i % mUSBIO_PACKET_LENGTH;  // ǰʣಿ
				mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STREAM;  // °
			}
		}
		mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STM_IN;  // һֽ,ֻһֽڲӦ
		mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STM_STO;  // ֹͣλ
		mBuffer[ i++ ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
		mLength = 0;
		if ( USBIO_WriteRead( iIndex, i, mBuffer, mUSBIOSS_CMD_I2C_STM_MAX, ( iInLength + mUSBIOSS_CMD_I2C_STM_MAX - 1 ) / mUSBIOSS_CMD_I2C_STM_MAX, &mLength, oInBuffer ) ) {  // ִ,
			if ( mLength == iInLength ) return( TRUE );
		}
	}
	return( FALSE );
}

/* ********************************************************************************************** */
/* :׼˫I/OչPCF8574 */

BOOL	WINAPI	PCF8574_WriteIO(  // PCF8574I/O
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iDeviceAddr,  // 豸ַ,λΪλ
	ULONG			iOutByte )  // ׼дI/O
{  // ֱUSBIO_StreamI2C( iIndex, 2, mBuffer, 0, NULL )ʵ
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength;
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = mUSBIOSS_CMD_I2C_STM_STA;  // ʼλ
	mBuffer[ 2 ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_OUT | 2 );  // ,λ5-λ0Ϊ,2ֽ
	mBuffer[ 3 ] = (UCHAR)( iDeviceAddr & 0xFE );  // 豸ַ,д
	mBuffer[ 4 ] = (UCHAR)iOutByte;  // I/O
	mBuffer[ 5 ] = mUSBIOSS_CMD_I2C_STM_STO;  // ֹͣλ
	mBuffer[ 6 ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 7;
	return( USBIO_WriteData( iIndex, mBuffer, &mLength ) );  // дݿ
}

BOOL	WINAPI	PCF8574_ReadIO(  // PCF8574I/O
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iDeviceAddr,  // 豸ַ,λΪλ
	PUCHAR			oInByte )  // ָһֽڵĻ,غǶI/O
{  // ֱUSBIO_StreamI2C( iIndex, 1, mBuffer, 1, oInByte )ʵ
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	ULONG	mLength, mInLen;
	mBuffer[ 0 ] = mUSBIOSS_CMD_I2C_STREAM;  // 
	mBuffer[ 1 ] = mUSBIOSS_CMD_I2C_STM_STA;  // ʼλ
	mBuffer[ 2 ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_OUT | 1 );  // ,λ5-λ0Ϊ,1ֽ
	mBuffer[ 3 ] = (UCHAR)( iDeviceAddr | 0x01 );  // 豸ַ,
	mBuffer[ 4 ] = (UCHAR)( mUSBIOSS_CMD_I2C_STM_IN | 1 );  // ,λ5-λ0Ϊ,1ֽ
	mBuffer[ 5 ] = mUSBIOSS_CMD_I2C_STM_STO;  // ֹͣλ
	mBuffer[ 6 ] = mUSBIOSS_CMD_I2C_STM_END;  // ǰǰ
	mLength = 7;
	mInLen = 0;
	if ( USBIO_WriteRead( iIndex, mLength, mBuffer, mUSBIOSS_CMD_I2C_STM_MAX, 1, &mInLen, mBuffer ) ) {  // ִ,
		if ( mInLen ) {
			*oInByte = mBuffer[ mInLen - 1 ];  // ص
			return( TRUE );
		}
	}
	return( FALSE );
}

/* ********************************************************************************************** */
/* :˫I/OչPCA9554 */

BOOL	WINAPI	PCA9554_SetIO(  // PCA9554I/O
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iDeviceAddr,  // 豸ַ,λΪλ
	ULONG			iSetByte )  // 
{  // ҲUSBIO_WriteI2Cʵ
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	mBuffer[ 0 ] = (UCHAR)( iDeviceAddr & 0xFE );  // 豸ַ,д
	mBuffer[ 1 ] = 0x03;
	mBuffer[ 2 ] = (UCHAR)iSetByte;  // I/O
	return( USBIO_StreamI2C( iIndex, 3, mBuffer, 0, NULL ) );  // I2C
}

BOOL	WINAPI	PCA9554_WriteIO(  // PCA9554I/O
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iDeviceAddr,  // 豸ַ,λΪλ
	ULONG			iOutByte )  // ׼дI/O
{  // ҲUSBIO_WriteI2Cʵ
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	mBuffer[ 0 ] = (UCHAR)( iDeviceAddr & 0xFE );  // 豸ַ,д
	mBuffer[ 1 ] = 0x01;
	mBuffer[ 2 ] = (UCHAR)iOutByte;  // I/O
	return( USBIO_StreamI2C( iIndex, 3, mBuffer, 0, NULL ) );  // I2C
}

BOOL	WINAPI	PCA9554_ReadIO(  // PCA9554I/O
	ULONG			iIndex,  // ָUSB2I2C豸
	ULONG			iDeviceAddr,  // 豸ַ,λΪλ
	PUCHAR			oInByte )  // ָһֽڵĻ,غǶI/O
{  // ҲUSBIO_ReadI2Cʵ
	UCHAR	mBuffer[ mUSBIO_PACKET_LENGTH ];
	mBuffer[ 0 ] = (UCHAR)( iDeviceAddr & 0xFE );  // 豸ַ,USBIO_StreamI2CԶ
	mBuffer[ 1 ] = 0x00;
	return( USBIO_StreamI2C( iIndex, 2, mBuffer, 1, oInByte ) );  // I2C
}

/* ********************************************************************************************** */

main( ) {
	return(1);
}