Attribute VB_Name = "USBIOX"
Option Explicit
' 2004.05.28, 2004.10.20, 2005.01.08, 2005.03.25, 2005.04.28
'****************************************
'**  Copyright  (C)  USBIO TECH.       **
'**  Web:  http://www.USB-I2C-SPI.com  **
'****************************************
'**  DLL for USB interface chip USB2SPI**
'**  C, VC6.0                          **
'****************************************
'
'****************************************************************************************************
'¶
'****************************************************************************************************
Public Enum EEPROM_TYPE   ' EEPROMͺŶ
  ID_24C01 = 0
  ID_24C02 = 1
  ID_24C04 = 2
  ID_24C08 = 3
  ID_24C16 = 4
  ID_24C32 = 5
  ID_24C64 = 6
  ID_24C128 = 7
  ID_24C256 = 8
  ID_24C512 = 9
  ID_24C1024 = 10
  ID_24C2048 = 11
  ID_24C4096 = 12
End Enum

Type mUspValue
        mUspValueLow As Byte                  ' 02H ֵֽ
        mUspValueHigh As Byte                 ' 03H ֵֽ
End Type
Type mUspIndex
        mUspIndexLow As Byte                  ' 04H ֽ
        mUspIndexHigh  As Byte                ' 05H ֽ
End Type
Type USB_SETUP_PKT                            ' USBƴĽ׶εṹ
    mUspReqType As Byte                       ' 00H 
    mUspRequest As Byte                       ' 01H 
    mUspValue As mUspValue                    ' 02H-03H ֵ
    mUspIndex As mUspIndex                    ' 04H-05H 
    mLength As Integer                        ' 06H-07H ݽ׶εݳ
End Type

Public Const INVALID_HANDLE_VALUE = -1        '
Public Const mUSBIO_PACKET_LENGTH = 32        ' USB2SPIֵ֧ݰĳ
Public Const mUSBIO_PKT_LEN_SHORT = 8         ' USB2SPIֵ֧Ķݰĳ


Type WIN32_COMMAND                              'WIN32ӿڽṹ
   mFunction As Long                            'ʱָܴ߹ܵ
                                                'ʱز״̬
   mLength As Long                              'ȡ,غݵĳ
   mBuffer(mUSBIO_PACKET_LENGTH - 1) As Byte    'ݻ,Ϊ0255B
End Type
Public mWIN32_COMMAND As WIN32_COMMAND

Public Const FILE_DEVICE_UNKNOWN = &H22
Public Const FILE_ANY_ACCESS = 0
Public Const METHOD_BUFFERED = 0
Public Const IOCTL_USBIO_COMMAND = (FILE_DEVICE_UNKNOWN * (2 ^ 16) + FILE_ANY_ACCESS * 2 ^ 14 + &HF34 * 2 ^ 2 + METHOD_BUFFERED)     ' רýӿ
Const mWIN32_COMMAND_HEAD = 8
Public Const mUSBIO_MAX_NUMBER = 16
Public Const mMAX_BUFFER_LENGTH = &H1000
Public Const mMAX_COMMAND_LENGTH = (mWIN32_COMMAND_HEAD + mMAX_BUFFER_LENGTH)
Public Const mDEFAULT_BUFFER_LEN = &H400
Public Const mDEFAULT_COMMAND_LEN = (mWIN32_COMMAND_HEAD + mDEFAULT_BUFFER_LEN)
Public Const mUSBIO_ENDP_INTER_UP = &H81
Public Const mUSBIO_ENDP_INTER_DOWN = &H1
Public Const mUSBIO_ENDP_DATA_UP = &H82
Public Const mUSBIO_ENDP_DATA_DOWN = &H2
Public Const mPipeDeviceCtrl = &H4
Public Const mPipeInterUp = &H5
Public Const mPipeDataUp = &H6
Public Const mPipeDataDown = &H7
Public Const mFuncNoOperation = &H0
Public Const mFuncGetVersion = &H1
Public Const mFuncGetConfig = &H2
Public Const mFuncSetTimeout = &H9
Public Const mFuncSetExclusive = &HB
Public Const mFuncResetDevice = &HC
Public Const mFuncResetPipe = &HD
Public Const mFuncAbortPipe = &HE
Public Const mFuncSetParaMode = &HF
Public Const mFuncReadData0 = &H10
Public Const mFuncReadData1 = &H11
Public Const mFuncWriteData0 = &H12
Public Const mFuncWriteData1 = &H13
Public Const mFuncWriteRead = &H14
Public Const mUSB_CLR_FEATURE = &H1
Public Const mUSB_SET_FEATURE = &H3
Public Const mUSB_GET_STATUS = &H0
Public Const mUSB_SET_ADDRESS = &H5
Public Const mUSB_GET_DESCR = &H6
Public Const mUSB_SET_DESCR = &H7
Public Const mUSB_GET_CONFIG = &H8
Public Const mUSB_SET_CONFIG = &H9
Public Const mUSB_GET_INTERF = &HA
Public Const mUSB_SET_INTERF = &HB
Public Const mUSB_SYNC_FRAME = &HC
Public Const mUSBIO_VENDOR_READ = &HC0
Public Const mUSBIO_VENDOR_WRITE = &H40
Public Const mUSBIO_PARA_INIT = &HB1
Public Const mUSBIO_I2C_STATUS = &H52
Public Const mUSBIO_I2C_COMMAND = &H53
Public Const mUSBIO_CMD_I2C_STM_STA = &H74
Public Const mUSBIO_CMD_I2C_STM_STO = &H75
Public Const mUSBIO_CMD_I2C_STM_OUT = &H0
Public Const mUSBIO_CMD_I2C_STM_IN = &HC0
Public Const mUSBIO_CMD_I2C_STM_SET = &H60
Public Const mUSBIO_CMD_I2C_STM_US = &H40
Public Const mUSBIO_CMD_I2C_STM_MS = &H50
Public Const mUSBIO_CMD_I2C_STM_DLY = &HF
Public Const mUSBIO_CMD_I2C_STM_END = &H0
Public Const mStateBitERR = &H100
Public Const mStateBitPEMP = &H200
Public Const mStateBitINT = &H400
Public Const mStateBitSLCT = &H800
Public Const mStateBitSDA = &H800000

'************************************************************************************************
'************************************************************************************************
'ΪUSBIOX.DLLṩҪI2C߶дAPI
'************************************************************************************************
'************************************************************************************************
Declare Function USBIO_StreamSPI4 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iChipSelect As Long, ByVal iLength As Long, ByRef ioBuffer As Any) As Boolean
' USBIO_StreamSPI4 SPI,4߽ӿ,ʱΪDCK/D3,ΪDOUT/D5,ΪDIN/D7,ƬѡΪD0/D1/D2,ٶԼ68Kֽ
' SPIʱ: DCK/D3Ϊʱ, ĬΪ͵ƽ, DOUT/D5ʱ֮ǰ, DIN/D7ʱ½֮
' iIndex,   ָUSB2SPI豸
' iChipSelect,Ƭѡ, λ7Ϊ0Ƭѡ, λ7Ϊ1Ч: λ1λ0Ϊ00/01/10ֱѡD0/D1/D2Ϊ͵ƽЧƬѡ
' iLength,    ׼ֽ
' ioBuffer    ָһ,׼DOUTд,غǴDIN



Declare Function USBIO_ReadI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDevice As Byte, ByVal iAddr As Byte, ByRef oByte As Byte) As Boolean
'  I2Cӿڶȡһֽ
'  iIndex,   ָUSB2SPI豸
'  iDevice,    7λָI2C豸ַ
'  iAddr,    ָݵԪĵַ
'  oByte    ָһֽڵԪ,ڱȡֽ

Declare Function USBIO_WriteI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDevice As Byte, ByVal iAddr As Byte, ByVal iByte As Byte) As Boolean
'    I2Cӿдһֽ
'    iIndex,   ָUSB2SPI豸
'    iDevice,   7λָI2C豸ַ
'    iAddr,  ָݵԪĵַ
'    iByte  дֽ

Declare Function USBIO_StreamI2C Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteLength As Long, ByRef iWriteBuffer As Any, ByVal iReadLength As Long, ByRef oReadBuffer As Any) As Boolean
' USBIO_StreamI2C I2C,2߽ӿ,ʱΪSCL,ΪSDA(׼˫I/O),ٶԼ56Kֽ
' iIndex,    ָUSB2SPI豸
' iWriteLength,    ׼дֽ
' iWriteBuffer,    ָһ,׼д,ֽͨI2C豸ַдλ
' iReadLength,     ׼ȡֽ
' oReadBuffer     ָһ,غǶ

Declare Function USBIO_ReadEEPROM Lib "USBIOX.DLL" (ByVal iIndexas As Long, ByVal iEepromID As EEPROM_TYPE, ByVal iAddr As Long, ByVal iLength As Long, ByRef oBuffer As Any) As Boolean
' USBIO_ReadEEPROM EEPROMжȡݿ,ٶԼ56Kֽ
' i    Index  ָUSB2SPI豸
' iEepromID   ָEEPROMͺ
' iAddr       ָݵԪĵַ
' iLength     ׼ȡֽ
' oBuffer     ָһ,غǶ

Declare Function USBIO_WriteEEPROM Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEepromID As EEPROM_TYPE, ByVal iAddr As Long, ByVal iLength As Long, ByRef iBuffer As Any) As Boolean
' USBIO_WriteEEPROM EEPROMдݿ
' iIndex,    ָUSB2SPI豸
' iEepromID, ָEEPROMͺ
' iAddr,     ָݵԪĵַ
' iLength,   ׼дֽ
' iBuffer    ָһ,׼д

Declare Function USBIO_SetStream Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iMode As Long) As Boolean
' iIndex,    ָUSB2SPI豸
' iMode      ָģʽ,
' λ1-λ0: I2Cӿٶ/SCLƵ, 00=/20KHz,01=׼/100KHz,10=/400KHz,11=/750KHz
' ,Ϊ0

Declare Function USBIO_GetStatus Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iStatus As Long) As Boolean
'  ͨUSB2SPIֱݺ״̬
'  iIndex,   ָUSB2SPI豸
'  iStatus  ָһ˫ֵԪ,ڱ״̬,
'  λ10ӦUSB2SPIINT#, λ11ӦUSB2SPISLCT, λ23ӦUSB2SPISDA

'************************************************************************************************
'************************************************************************************************
'ΪUSBIOX.DLLṩҪ豸API
'************************************************************************************************
'************************************************************************************************

Declare Function USBIO_OpenDevice Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long
' USB2SPI豸,ؾ,Ч
' iIndex  ָUSB2SPI豸,0Ӧһ豸

Declare Sub USBIO_CloseDevice Lib "USBIOX.DLL" (ByVal iIndex As Long)
' رUSB2SPI豸
' iIndex    ָUSB2SPI豸

Declare Function USBIO_GetVersion Lib "USBIOX.DLL" () As Long
Declare Function USBIO_GetDrvVersion Lib "USBIOX.DLL" () As Long
' 汾,ذ汾,򷵻0

Declare Function USBIO_ResetDevice Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'λUSB豸
' iIndex  ָUSB2SPI豸

Declare Function USBIO_GetDeviceDescr Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡ豸
' iIndex,   ָUSB2SPI豸
' oBuffer   ָһ㹻Ļ,ڱ
' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_GetConfigDescr Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡ
'  iIndex,    ָUSB2SPI豸
'  oBuffer,   ָһ㹻Ļ,ڱ
'  ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_SetIntRoutine Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iIntRoutine As Long) As Boolean
'趨жϷ
' ָUSB2SPI豸
'ָжϷ,ΪNULLȡжϷ,жʱøó

Declare Function USBIO_ReadInter Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iStatus As Long) As Boolean
' ȡж
' iIndex,  ָUSB2SPI豸
' iStatus   ָһ˫ֵԪ,ڱȡж״̬,
' λ7-λ0ӦUSB2SPID7-D0
'  λ8ӦUSB2SPIERR#, λ9ӦUSB2SPIPEMP, λ10ӦUSB2SPIINT#, λ11ӦUSB2SPISLCT

Declare Function USBIO_AbortInter Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' жݶ
' iIndex   ָUSB2SPI豸

Declare Function USBIO_ReadData0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' 0#˿ڶȡݿ
 ' iIndex     ָUSB2SPI豸
 ' oBuffer   ָһ㹻Ļ,ڱȡ
 ' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_ReadData1 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' 1#˿ڶȡݿ
' iIndex,  ָUSB2SPI豸
' oBuffer ָһ㹻Ļ,ڱȡ
' ioLength   ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_AbortRead Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' ݿ
' iIndex    ָUSB2SPI豸

Declare Function USBIO_WriteData0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
' 0#˿дݿ
' iIndex,    ָUSB2SPI豸
' iBuffer     ָһ,׼д
' ioLength  ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_WriteData1 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
' 1#˿дݿ
' iIndex,    ָUSB2SPI豸
' iBuffer,    ָһ,׼д
' ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_AbortWrite Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' ݿд
' iIndex   ָUSB2SPI豸

Declare Function USBIO_SetExclusive Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iExclusive As Long) As Boolean
' öռʹõǰUSB2SPI豸
' iIndex,    ָUSB2SPI豸
' iExclusive  Ϊ0豸Թʹ,0ռʹ

Declare Function USBIO_SetTimeout Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteTimeout As Long, ByVal iReadTimeout As Long) As Boolean
'  USBݶдĳʱ
'  iIndex,  // ָUSB2SPI豸
'  iWriteTimeout  ָUSBдݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
'  iReadTimeout  ָUSBȡݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)

Declare Function USBIO_ReadData Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef oBuffer As Any, ByRef ioLength As Long) As Boolean
' ȡݿ
' iIndex,    ָUSB2SPI豸
' oBuffer,    ָһ㹻Ļ,ڱȡ
' ioLength      ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ

Declare Function USBIO_WriteData Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iBuffer As Any, ByRef ioLength As Long) As Boolean
'  дݿ
'  iIndex,    ָUSB2SPI豸
'  iBuffer,    ָһ,׼д
'  ioLength   ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ

Declare Function USBIO_Set_D5_D0 Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iSetDirOut As Long, ByVal iSetDataOut As Long) As Boolean
' USBIO_Set_D5_D0 USB2SPID5-D0ŵI/O,ͨUSB2SPID5-D0ֱ
' ***** ʹøAPI, ֹ޸I/OʹűΪŵ֮·оƬ *****
' iIndex,      ָUSB2SPI豸
' iSetDirOut,  D5-D0ŵI/O,ĳλ0ӦΪ,ĳλ1ӦΪ,ڷʽĬֵΪ0x00ȫ
' iSetDataOut  D5-D0ŵ,I/OΪ,ôĳλ0ʱӦ͵ƽ,ĳλ1ʱӦߵƽ
'// ݵλ5-λ0ֱӦUSB2SPID5-D0


Declare Function USBIO_GetDeviceName Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long           ''''
' ָUSB2SPI豸ƵĻ,򷵻NULL
' iIndex   ָUSB2SPI豸,0Ӧһ豸

Declare Function USBIO_GetVerIC Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long
' iIndex  ָUSB2SPI豸

Declare Function USBIO_FlushBuffer Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
' USB2SPIĻ
' iIndex   ָUSB2SPI豸

Declare Function USBIO_WriteRead Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iWriteLength As Long, ByRef iWriteBuffer As Any, ByVal iReadStep As Long, ByVal iReadTimes As Long, ByRef oReadLength As Long, ByRef oReadBuffer As Any) As Boolean
' iIndex,    ָUSB2SPI豸
' iWriteLength,   д,׼дĳ
' iWriteBuffer,    ָһ,׼д
' iReadStep,    ׼ȡĵĳ, ׼ȡܳΪ(iReadStep*iReadTimes)
' iReadTimes,    ׼ȡĴ
' oReadLength,    ָ򳤶ȵԪ,غΪʵʶȡĳ
' oReadBuffer      ָһ㹻Ļ,ڱȡ

Declare Function USBIO_SetDelaymS Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iDelay As Long) As Boolean
'  USBIO_SetDelaymS     Ӳ첽ʱ,úܿ췵,һ֮ǰʱָ
 ' iIndex,    ָUSB2SPI豸
 ' iDelay      ָʱĺ

Declare Function USBIO_SetBufUpload Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEnableOrClear As Long) As Boolean  ' Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
' USBIO_SetBufUpload  ' 趨ڲϴģʽ
' iIndex,          0ָUSB2SPI豸,0Ӧһ豸
' iEnableOrClear  Ϊ0ֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
' ڲϴģʽ,ôUSB2SPI򴴽߳ԶUSBϴݵڲ,ͬʱе,ӦóUSBIO_ReadDataػе

Declare Function USBIO_QueryBufUpload Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long
' USBIO_QueryBufUpload   ѯڲϴеݰ,ɹݰ,-1
' iIndex                ָUSB2SPI豸,0Ӧһ豸

Declare Function USBIO_SetBufDownload Lib "USBIOX.DLL" (ByVal iIndex As Long, ByVal iEnableOrClear As Long) As Boolean
'  USBIO_SetBufDownload  趨ڲ´ģʽ
'  iIndex,              ָUSB2SPI豸,0Ӧһ豸
'  iEnableOrClear       Ϊ0ֹڲ´ģʽ,ʹֱ´,0ڲ´ģʽе
'  ڲ´ģʽ,ôӦóUSBIO_WriteData󽫽ǽUSB´ݷŵڲ,USB2SPI򴴽߳Զֱ

Declare Function USBIO_QueryBufDownload Lib "USBIOX.DLL" (ByVal iIndex As Long) As Long    ' ָUSB2SPI豸,0Ӧһ豸
'  USBIO_QueryBufDownload  ѯڲ´еʣݰ(δ),ɹݰ,-1
'  iIndex                 ָUSB2SPI豸,0Ӧһ豸

Declare Function USBIO_ResetInter Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'  USBIO_ResetInter   λжݶ
'  iIndex            ָUSB2SPI豸

Declare Function USBIO_ResetRead Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'  USBIO_ResetRead  λݿ
'  iIndex          ָUSB2SPI豸

Declare Function USBIO_ResetWrite Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'Declare Function USBIO_ResetWrite Lib "USBIOX.DLL" (ByVal iIndex As Long) As Boolean
'    USBIO_ResetRead    λݿ
'    iIndex            ָUSB2SPI豸

Public Const USBIO_DEVICE_ARRIVAL = 3               ' 豸¼,Ѿ
Public Const USBIO_DEVICE_REMOVE_PEND = 1         ' 豸Ҫγ
Public Const USBIO_DEVICE_REMOVE = 0              ' 豸γ¼,Ѿγ

Declare Function USBIO_SetDeviceNotify Lib "USBIOX.DLL" (ByVal iIndex As Long, ByRef iDeviceID As String, ByVal iNotifyRoutine As Long) As Boolean
'  USBIO_SetDeviceNotify     趨豸¼֪ͨ
'  iIndex,                  ָUSB2SPI豸,0Ӧһ豸
'  iDeviceID,               ѡ,ַָ,ָص豸ID,ַ\0ֹ
'  iNotifyRoutine           (ַ)ָ豸¼ص, ΪNULLȡ¼֪ͨ, ڼ⵽¼ʱøó
