// V1.1
/* ********************************************************************************************** */
/* :4߽ӿSPI洢25F51225F020 */
/* : USB2SPI_SCK/D3 <-> 25FXX_SCK, USB2SPI_DO/D5 <-> 25FXX_SI, USB2SPI_DI/D7 <-> 25FXX_SO, USB2SPI_CS0 <-> 25FXX_CS# */

BOOL	WINAPI	AT25F512_ReadBlock(  // AT25F512Ŀ (:,3ֽڹ24λַ,ݿ)
	ULONG			iIndex,  // ָUSB2SPI豸
	ULONG			iAddress,  // ַָ
	ULONG			iInLength,  // ׼ȡֽ,νС1024ֽ
	PVOID			oInBuffer )  // ָһ,غǶ
{
	static	BOOL	mTheFirst = TRUE;
	if ( mTheFirst ) {  // ״νʱҪI/O
		if ( USBIO_SetStream( iIndex, 0x81 ) == FALSE ) return( FALSE );  // ôģʽ:SPIΪ뵥,SPIֽеλ˳Ǹλǰ
		mTheFirst = FALSE;
	}
	if ( iInLength == 0 || iInLength > mDEFAULT_BUFFER_LEN ) return( FALSE );
	*( (PUCHAR)oInBuffer + 0 ) = 0x03;  // 洢,עһͬ
	*( (PUCHAR)oInBuffer + 1 ) = (UCHAR)( iAddress >> 16 & 0xFF );  // ָĵַA23-A16
	*( (PUCHAR)oInBuffer + 2 ) = (UCHAR)( iAddress >> 8 & 0xFF );  // ָĵַA15-A8
	*( (PUCHAR)oInBuffer + 3 ) = (UCHAR)( iAddress & 0xFF );  // ָĵַA7-A0
//	memset( (PUCHAR)oInBuffer + 4, 0xFF, iInLength );  // ЩSPI,ҪڶʱSI뱣Ϊ10,ôҪڴ
	if ( USBIO_StreamSPI4( iIndex, 0x80, iInLength + 4, oInBuffer ) == FALSE ) return( FALSE );  // 4߽ӿSPI,ԶƬѡΪCS0
/* 25F512Ķ,Ҫ4ֽַ,ɸֽ,APIAPIʱָܳ,Էݵǰ4ֽַʱ,Ӧö */
	memmove( oInBuffer, (PUCHAR)oInBuffer + 4, iInLength );  // ΪUSB2SPISPI,ʵʷӦȥԼ4ֽ(͵ַ)
	return( TRUE );
}

/* ********************************************************************************************** */
/* :SPIķǱ׼ʱ8λADCоƬADC0831TLC0831 */
/* : USB2SPI_SCK/D3 <-> ADC0831_CLK, USB2SPI_DI/D7 <-> ADC0831_DO, USB2SPI_CS2 <-> ADC0831_CS# */

BOOL	WINAPI	ADC0831_ReadADC(  // ȡADC
	ULONG			iIndex,  // ָUSB2SPI豸
	PUCHAR			oADC )  // ָһֽڵԪ,ضADC
{
	static	BOOL	mTheFirst = TRUE;
	UCHAR	mBuffer[ 256 ];
	ULONG	i;
	if ( mTheFirst ) {  // ״νʱҪI/O
		if ( USBIO_Set_D5_D0( iIndex, 0x0C, 0x04 ) == FALSE ) return( FALSE );  // USB2SPID5-D0ŵI/O,DCK/D3ĬΪ0,D2ĬΪ1
		mTheFirst = FALSE;
	}
	for ( i = 0; i < 12; i ++ ) {
		mBuffer[ i ] = 0x00;  // CS=0 for 1st bit to 12th bit
	}
	mBuffer[ i++ ] = 0x04;  // CS=1 for 13th bit
	if ( USBIO_BitStreamSPI( iIndex, i, mBuffer ) == FALSE ) return( FALSE );  // SPIλ,13λ,ʵδȫõ
	*oADC = 0;
	for ( i = 0; i < 8; i ++ ) {  // ÿֽڵλ7ϲΪ8λADC
		*oADC = ( *oADC << 1 ) | ( mBuffer[ i + 1 ] >> 7 );  // λ7Ƶλ0,ֽЧ,2ʱӵݲMSBλ
	}
	return( TRUE );
}

